<?php
/**
 * The template for displaying Author bios
 *
 */
?>

<?php if ( !get_the_author_meta( 'ID' ) ) return;

$author_id = get_the_author_meta( 'ID' );

if ( !is_author() ) { ?>

	<a class="a-a a-a--h" href="<?php echo esc_url( get_author_posts_url( get_the_author_meta( 'ID' ) ) ); ?>" rel="author">

		<h2 class="pht-heading widget-title pht-mb0">
			<?php echo esc_html( apply_filters( 'yaga_about_author_title_text', esc_html__( 'About the author', 'yaga' ) ) ); ?>
		</h2>
		<h3 class="pht-subheading pht-subtitle">
			<?php echo esc_html( apply_filters( 'yaga_about_author_subtitle_text', get_the_author_meta( 'display_name', $author_id ) ) ); ?>
		</h3>
	</a>

<?php } else { ?>

		<h2 class="pht-heading">
			<?php echo esc_html( apply_filters( 'yaga_about_author_title_text', esc_html__( 'About the author', 'yaga' ) ) ); ?>
		</h2>

<?php } ?>

	<div class="author-description media">

	<?php $author_bio_avatar_size = apply_filters( 'yaga_author_bio_avatar_size', 128 );

		echo get_avatar( get_the_author_meta( 'user_email', $author_id ) , $author_bio_avatar_size );

		echo wpautop( get_the_author_meta( 'description' ) );

		$twitter_url = get_the_author_meta( PeHaaThemes_Theme_Start::$mb_prefix . 'twitter_url', $author_id );
		$dribbble_url = get_the_author_meta( PeHaaThemes_Theme_Start::$mb_prefix . 'dribbble_url', $author_id );
		$facebook_url = get_the_author_meta( PeHaaThemes_Theme_Start::$mb_prefix . 'facebook_url', $author_id );
		$googleplus_url = get_the_author_meta( PeHaaThemes_Theme_Start::$mb_prefix . 'googleplus_url', $author_id );

		$website_url = get_the_author_meta( 'user_url', $author_id );

		if ( $twitter_url || $dribbble_url || $facebook_url || $googleplus_url || $website_url ) { ?>

		<div class="pht-text-right">
			<?php if ( $twitter_url ) { ?>
				<a class='pht-icon pht-icon--tiny pht-icon--border pht-btn--pill' href="<?php echo esc_url( $twitter_url ); ?>" target="_blank" title="<?php esc_html_e( 'Twitter profile', 'yaga' ); ?>"><i class="pht-ic-f1-twitter"></i></a>
			<?php }?>
			<?php if ( $dribbble_url ) { ?>
				<a class='pht-icon pht-icon--tiny pht-icon--border pht-btn--pill' href="<?php echo esc_url( $dribbble_url ); ?>" target="_blank" title="<?php esc_html_e( 'Dribbble profile', 'yaga' ); ?>"><i class="pht-ic-f1-dribbble"></i></a>
			<?php }?>
			<?php if ( $facebook_url ) { ?>
				<a class='pht-icon pht-icon--tiny pht-icon--border pht-btn--pill' href="<?php echo esc_url( $facebook_url ); ?>" target="_blank" title="<?php esc_html_e( 'Facebook profile', 'yaga' ); ?>"><i class="pht-ic-f1-facebook"></i></a>
			<?php }?>
			<?php if ( $googleplus_url ) { ?>
				<a class='pht-icon pht-icon--tiny pht-icon--border pht-btn--pill' href="<?php echo esc_url( $googleplus_url ); ?>"  target="_blank" title="<?php esc_html_e( 'Google+ profile', 'yaga' ); ?>"><i class="pht-ic-f1-googleplus"></i></a>
			<?php }?>
			<?php if ( $website_url ) { ?>
				<a class='pht-icon pht-icon--tiny pht-icon--border pht-btn--pill' href="<?php echo esc_url( $website_url ); ?>" target="_blank" title="<?php esc_html_e( 'Website', 'yaga' ); ?>"><i class="pht-ic-f1-link"></i></a>
			<?php }?>
		</div>

	<?php } ?>

	</div><!-- .author-description -->