<?php
/**
 * The template for displaying the footer
 *
 * Contains the closing of the "#main" and "#page" divs and all content after.
 *
 * @since Yaga 1.0.0
 */

		
?>

</main><!-- #main -->

</div><!-- #page -->

<?php do_action( 'yaga_before_footer' ); ?>

<?php $fixed_footer = get_theme_mod( 'yaga_fixed_footer', '1' );

$footer_class = '';

if ( $fixed_footer ) { 

	$footer_class = 'site-footer--fixed'; ?>
	
	<div id="colophon-height" class="hidden--below-wide"></div>

<?php } ?>

<footer id="colophon" class="site-footer pht-parent <?php echo esc_attr( $footer_class ); ?>">

	<?php if ( isset( PeHaaThemes_Theme_Config::$sidebar->display_footer ) ? PeHaaThemes_Theme_Config::$sidebar->display_footer : true ) { ?>

		<div class="pht-wrapper pht-hider js-pht-waypoint pht-waypoint pht-t2b ">

			<?php 
			echo '<div id="footer-sidebar" class="site-footer__sidebar widget-area pht-layout container-a container-a--alt-h"><!--';
			do_action( 'yaga_footer_sidebar_starts' );
			dynamic_sidebar( isset(  PeHaaThemes_Theme_Config::$sidebar->display_footer_id ) ? PeHaaThemes_Theme_Config::$sidebar->display_footer_id : 'footer-sidebar' );
			do_action( 'yaga_footer_sidebar_ends' );
			echo '--></div>';
			?>
		
		</div><!-- .pht-wrapper -->

	<?php } ?>

	<div id="site-info" class="site-footer__info pht-box container-a container-a--alt-h">
		
		<div class="pht-wrapper">
			<?php 
			$custom_footer_copy = trim( get_theme_mod( 'yaga_footer_copy' ) );
			$custom_footer_copy_right = trim( get_theme_mod( 'yaga_footer_copy_right' ) );
			
			$copy = $custom_footer_copy ? $custom_footer_copy : '&copy; ' . date( 'Y' ) . ' ' . esc_html( get_bloginfo( 'name' ) );
			$copy_right = $custom_footer_copy_right ? $custom_footer_copy_right : sprintf( esc_html__( 'Theme by %s', 'yaga' ), '<a href="' . esc_url( PeHaaThemes_Theme_Start::$theme_author_uri ) . '">' . esc_html( PeHaaThemes_Theme_Start::$theme_author ) . '</a>' ); 

			$classes = 'pht-layout__item u-1-of-2-desk js-pht-waypoint pht-waypoint'; ?>

			<p class="site-footer__copy pht-layout">
				<?php printf( '<span class="%1$s">%2$s</span><!--', $classes . ' pht-b2t', $copy );
				printf( '--><span class="site-footer__author %1$s">%2$s</span>', $classes . ' pht-b2t', $copy_right ); ?>
			</p>
		
		</div><!-- .pht-wrapper -->

	</div><!-- #site-info -->
	
</footer>
<a id="pht-back-to-top" href="#body" title="<?php esc_html_e( 'Back to top', 'yaga' ); ?>" class="pht-transition pht-icon pht-back-to-top"><i class="pht-ic-f1-caret-up"></i></a>

<?php do_action( 'yaga_after_footer' );

wp_footer(); ?>
</body>
</html>