<?php
/**
 *
 * @package   Yaga
 * @subpackage   Yaga/includes
 * @author    PeHaa THEMES <info@pehaa.com>
 * @since Yaga 1.0.0
 */

/**
 * Theme configuration class. 
 *
 * @package Yaga
 * @author  PeHaa THEMES <info@pehaa.com>
 */

if ( ! class_exists( 'PeHaaThemes_Theme_Config' ) ) :

class PeHaaThemes_Theme_Config {

	public static $id = 0;

	public static $use_phtpb = false;

	private static $custom_width = 1140;

	private static $alt_custom_width = 752;

	private static $instance = null;

	public static $sidebar;

	public static $user_logo;

	public static $navigation = 'default';

	private $theme_supports = array(
		array(
			'feature' => 'post-thumbnails'
		),
		array(
			'feature' => 'html5',
			'args' => array( 'search-form', 'comment-form', 'comment-list', 'gallery', 'caption' )
		),
		array(
			'feature' => 'automatic-feed-links',
		),
		array(
			'feature' => 'post-formats',
			'args' => array( 'gallery', 'image', 'video', 'audio', 'aside' )
		)
	);

	public static $image_sizes = array();

	public static $menu_locations = array( 'main_navigation' => 'Main Navigation' );

	public $nice_excerpts = false;

	public $tiled_gallery = true;

	public static $override_post_gallery = true;

	public $megamenu = true;

	public static $navigation_breakpoint = 1280;

	public static $tag_cloud_args = array( 'largest' => .875, 'smallest' => .875, 'unit' => 'rem', 'separator' => ' &middot; ', 'orderby' => 'count' );

	public static $body_font = 'Merriweather';

	public static $body_normal_weight = '400';

	public static $body_bold_weight = '700';

	public static $body_font_family = 'serif';

	public static $headings_font = 'Unica One';

	public static $headings_font_family = 'sans-serif';

	public static $headings_weight = '400';

	public static $logo_height = 48;

	public static $mini_logo_height = 32;

	public static $html_bg = '#f6f6f6';

	public static $main_nav_drop_bg = '#ffffff';

	public static $footer_bg = '#e0e1e2';

	public static $footer_copy_bg = '#d9dadb';

	public static $box_bg = '#ffffff';

	public static $link_color = '#818181';

	public static $link_color_1 = '#a7bec9';

	public static $hover_overlay_opacity = 0.85;

	public static $overlay_bg = '#f6f6f6';

	public static $color = '#303030';

	public static $footer_color = '#303030';

	public static $entry_bottom_meta = array(

		'date' => false,

		'author' => '1',

		'categories' => '1',
		
		'comments' => '1'
	);

	private static $load_more_nonce = 'yaga-load-more';

	public static $search_in_nav = true;

	public static $public_style_deps = array();

	public static $theme_filter_hooks = array(

		array(
			'hook' => 'body_class',
			'method' => 'yaga_body_class',
		),

		array(
			'hook' => 'template_redirect',
			'method' => 'yaga_get_id',
			'priority' => 1
		),

		array(
			'hook' => 'template_redirect',
			'method' => 'yaga_pre_phtpb',
			'priority' => 1
		),

		array(
			'hook' => 'template_redirect',
			'method' => 'yaga_pre_sidebar',
			'priority' => 1
		),

		array(
			'hook' => 'template_redirect',
			'method' => 'yaga_adjust_content_width',
			'priority' => 2
		),

		array(
			'hook' => 'embed_defaults',
			'method' => 'yaga_default_width'
		),
		array(
			'hook' => 'wp_footer',
			'method' => 'yaga_user_footer_scripts'
		),
		array(
			'hook' => 'get_header',
			'method' => 'yaga_pre_site_header',
		),
		array(
			'hook' => 'wp_head',
			'method' => 'yaga_user_header_scripts',
			'priority' => 99
		),
		array(
			'hook' => 'widget_tag_cloud_args',
			'method' => 'yaga_tag_cloud_args'
		),
		array(
			'hook' => 'after_setup_theme',
			'method' => 'yaga_add_image_sizes'
		),
		array(
			'hook' => 'after_setup_theme',
			'method' => 'yaga_register_menus'
		),
		array(
			'hook' => 'get_avatar',
			'method' => 'yaga_add_media_class'
		),
		array(
			'hook' => 'image_size_names_choose',
			'method' => 'yaga_custom_sizes_names'
		),
		array(
			'hook' => 'get_header',
			'method' => 'yaga_remove_admin_margin_top'
		),
		array(
			'hook' => 'phtpb_load_public_scripts',
			'method' => 'yaga_dont_do',
			'args' => 2
		),
		array(
			'hook' => 'phtpb_theme_script_handler',
			'method' => 'yaga_theme_script_handler',
		),
		array(
			'hook' => 'phtpb_load_public_styles',
			'method' => 'yaga_dont_do',
			'args' => 2
		),
		array(
			'hook' => 'phtpb_load_public_modernizr',
			'method' => 'yaga_dont_do',
			'args' => 2
		),
		array(
			'hook' => 'admin_enqueue_scripts',
			'method' => 'yaga_load_wp_media_files'
		),
		/*array(
			'hook' => 'admin_enqueue_scripts',
			'method' => 'yaga_custom_metaboxes_script',
		),*/
		array(
			'hook' => 'wp_ajax_yaga_load_more',
			'method' => 'yaga_load_more'
		),
		array(
			'hook' => 'wp_ajax_nopriv_yaga_load_more',
			'method' => 'yaga_load_more',
		),
		array(
			'hook' => 'wp_enqueue_scripts',
			'method' => 'yaga_enqueue_public_scripts',
		),
		array(
			'hook' => 'widgets_init',
			'method' => 'yaga_custom_widgets'
		),
		array(
			'hook' => 'dynamic_sidebar_params',
			'method' => 'yaga_footer_sidebar_count'
		),
		array(
			'hook' => 'the_password_form',
			'method' => 'yaga_password_form'
		),
		array(
			'hook' => 'yaga_preloader',
			'method' => 'yaga_preloader'
		),
		array(
			'hook' => 'yaga_display_site_header',
			'method' => 'yaga_display_site_header'
		),
		/*array(
			'hook' => 'get_the_excerpt',
			'method' => 'yaga_excerpt_link'
		),*/
		array(
			'hook' => 'after_setup_theme',
			'method' => 'add_editor_styles'
		),
		array(
			'hook' => 'mce_buttons_2',
			'method' => 'yaga_add_styleselect_button'
		),
		array(
			'hook' => 'tiny_mce_before_init',
			'method' => 'yaga_mce_before_init_insert_formats'
		),
		array(
			'hook' => 'get_search_form',
			'method' => 'yaga_search_form'
		),
		array(
			'hook' => 'pehaathemes_theme_started',
			'method' => 'yaga_extend_library'
		),
		array(
			'hook' => 'yaga_html_classes',
			'method' => 'yaga_html_classes'
		)
	);

	private static $modernizr_version = '3.2.0';

	public static $use_google_fonts = true;

	public static $yaga_footer_widget_areas_defaults =  array(
		'before_widget' => '--><aside id="%1$s" class="widget pht-layout__item u-1-of-4-desk u-1-of-2-lap u-1-of-1 palm-maxwidth palm-centered %2$s">',
		'after_widget' => '</aside><!--',
	);

	public static $yaga_sidebar_widget_areas_defaults =   array(
		'before_widget' => '<aside id="%1$s" class="widget %2$s">',
		'after_widget' => '</aside>',
	);	
	
	public static $single_items = array( 'post' ); /* used for meta-boxes */

	private function __construct() {

		global $content_width;

		if ( ! isset( $content_width ) ) {

			$content_width = self::$custom_width;

		}

		add_action( 'customize_preview_init', array( $this, 'refresh_for_preview' ), 11 );

		self::$image_sizes = array(
			'yaga-full-width' => array(
				'width' => self::$custom_width,
				'height' => '',
				'crop' => true,
				'title' => esc_html__( 'Full width', 'yaga' )
			),
			'yaga-post-grid' => array(
				'width' => 480,
				'height' => '',
				'crop' => true
			),
			'yaga-post-view' => array(
				'width' => self::$alt_custom_width,
				'height' => '',
				'crop' => true,
				'title' => esc_html__( 'Two columns width', 'yaga' )
			),
			'yaga-post-grid-gallery' => array(
				'width' => 480,
				'height' => 320,
				'crop' => true
			),
			'yaga-post-grid-shop' => array(
				'width' => 558,
				'height' => 558,
				'crop' => true
			),
		);

		self::$user_logo = get_theme_mod( 'yaga_login_logo' );
		self::$navigation = pehaathemes_get_theme_mod_not_empty( 'yaga_navigation', 'default' );
		
		if ( in_array( self::$navigation, array( 'top_fixed_fixed', 'top_fixed_center' ) ) ) {
			self::$navigation_breakpoint = 1024;
		}

		$side = array(
			'name' => esc_html__( 'Sidebar Widgets Area', 'yaga' ),
			'description' => esc_html__( 'Sidebar widget area.', 'yaga' ),
			'id' => 'sidebar-1',
		);
		$side = wp_parse_args( $side, self::$yaga_sidebar_widget_areas_defaults  );

		$footer = array(
			'name' => esc_html__( 'Footer Widgets Area', 'yaga' ),
			'description' => esc_html__( 'Footer widget area.', 'yaga' ),
			'id' => 'sidebar-2',
		);
		$footer = wp_parse_args(  $footer, self::$yaga_footer_widget_areas_defaults );

		add_action( 'template_redirect', array( $this, 'template_related_behavior' ) );
			
		$this->theme_child_ready();
		$this->load_classes_and_template_tags();

		do_action( 'yaga_classes_and_template_tags_loaded' );
		
		new PeHaaThemes_Widgets_Area( $side );
		new PeHaaThemes_Widgets_Area( $footer );

	}

	public static function get_instance() {

		if ( null == self::$instance ) {
			self::$instance = new self();
		}

		return self::$instance;

	}

	public function refresh_for_preview() {
		self::$navigation = pehaathemes_get_theme_mod_not_empty( 'yaga_navigation', 'default' );
	}

	public function template_related_behavior() {

		if ( 'loadmore' === get_theme_mod( 'yaga_pagination' ) && ( is_home() || is_archive( 'post' ) ) ) {
			self::$public_style_deps[] = 'wp-mediaelement';
		}
	}

	public function theme_child_ready() {

		$to_apply_filters = get_class_vars( __CLASS__ );

		foreach ( $to_apply_filters as $key => $array ) {

			if ( in_array( $key, array( 'phtpb', 'instance', 'sidebar', 'load_more_nonce' ) ) ) {
				continue;
			}

			if ( isset( $this->$key ) ) {

				$this->$key = apply_filters( 'yaga_' . $key, $this->$key );

			} elseif ( isset( self::$$key ) ) {

				self::$$key = apply_filters( 'yaga_' . $key, self::$$key );

			}

		}

	}

	private function load_classes_and_template_tags() {
		
		require_once PEHAATHEMES_INCLUDES_DIR . '/class-yaga-megamenu-walker.php' ;
		require_once PEHAATHEMES_INCLUDES_DIR . '/metaboxes/metaboxes-single.php';
		require_once PEHAATHEMES_INCLUDES_DIR . '/metaboxes/metaboxes-user.php';
		require_once PEHAATHEMES_INCLUDES_DIR . '/class-yaga-entry.php';
		require_once PEHAATHEMES_INCLUDES_DIR . '/class-yaga-view.php';
		require_once PEHAATHEMES_INCLUDES_DIR . '/class-yaga-single-view.php';
		require_once PEHAATHEMES_INCLUDES_DIR . '/class-yaga-page-header.php';
		require_once PEHAATHEMES_INCLUDES_DIR . '/class-yaga-sidebar.php';
		require_once PEHAATHEMES_INCLUDES_DIR . '/class-yaga-site-header.php';
		require_once PEHAATHEMES_INCLUDES_DIR . '/class-yaga-woocommerce.php';
		require_once PEHAATHEMES_INCLUDES_DIR . '/class-yaga-customizer.php';
		require_once PEHAATHEMES_INCLUDES_DIR . '/class-yaga-walker-comments.php';

		if ( class_exists( 'PeHaa_Themes_Page_Builder' ) ) {

			require_once PEHAATHEMES_INCLUDES_DIR . '/class-yaga-phtpb-addons.php';
			Yaga_PHTPB_Addons::get_instance();	
			require_once PEHAATHEMES_INCLUDES_DIR . '/class-yaga-phtpb-shortcode-template.php';
			do_action( 'yaga_addons_class_loaded');
			
		
		}
		
		if ( is_admin() ) {
			require_once PEHAATHEMES_INCLUDES_DIR . '/setup/class-yaga-setup.php';
			Yaga_Setup::get_instance();
		}

	}

	public static function yaga_extend_library() {

		if ( class_exists( 'PeHaaThemes_Tiled_Gallery' ) ) {

			require_once PEHAATHEMES_INCLUDES_DIR . '/class-yaga-tiled-gallery.php';
		
		}
	}

	public function get_theme_supports() {

		if ( !is_array( $this->theme_supports ) ) {
			return array();
		}

		return $this->theme_supports;

	}

	public static function yaga_body_class( $classes ) {

		$classes[] = 'pht-not-scrolled';
		$classes[] = 'pht-minified-menu';

		if ( self::$id ) {
			$skip_elements = get_post_meta( self::$id, PeHaaThemes_Theme_Start::$mb_prefix . 'post_skip_elements', true ) ? get_post_meta( self::$id, PeHaaThemes_Theme_Start::$mb_prefix . 'post_skip_elements', true ) : array();
			$page_header_w_img = get_post_meta( self::$id, PeHaaThemes_Theme_Start::$mb_prefix . 'post_header_checked', true );
			if ( in_array( 'header', $skip_elements ) && !post_password_required( self::$id ) ) {
				if ( !in_array( self::$navigation, array( 'top_fixed_full', 'top_fixed_center', 'top_fixed_fixed' ) ) ) {
					$classes[] = 'js-body--nopageheader';
					$classes[] = 'body--nopageheader';
				}		
				
			} else {
				$classes[] = 'body--pageheader';
			}
			if ( in_array( $page_header_w_img,  array( 'yes_all', 'yes' ) ) ) {
				$classes[] = 'body--page-header-w-img';
				$classes[] = 'body--page-header-img--' . $page_header_w_img;
			}
			if ( in_array( self::$navigation, array( 'sticky_center', 'sticky_full' ) ) ) {
				if ( in_array( 'navigation', $skip_elements ) ) {
					$classes[] = 'pht-skip-non-sticky';
				}
				if ( in_array( 'title', $skip_elements ) ) {
					$classes[] = 'pht-hide-title';
				}
			}
		}

		if ( self::$use_phtpb && !post_password_required( self::$id ) ) {
			$classes[] = 'body--phtpb';
		}

		if ( Yaga_Site_Header::$display_preloader ) {
			$classes[] = 'js-unloaded js-with-preloader';
		} else {
			$classes[] = 'js-loaded js-no-preloader';
		}
		if ( Yaga_Site_Header::$fullpage_logo ) {
			$classes[] = 'pht-fp-logo';
			$classes[] = 'pht-fp-logo-' . Yaga_Site_Header::$fullpage_logo;
		} else {
			$classes[] = 'pht-fp-nologo';
		}
		if ( Yaga_Site_Header::$display_site_tagline ) {
			$classes[] = 'pht-with-tagline';
		}
		if ( Yaga_Site_Header::$display_site_title ) {
			$classes[] = 'pht-with-title';
		}

		if ( in_array( get_theme_mod( 'yaga_headings_font_family' ), array( 'cursive', 'fantasy' ) ) ) {
			$classes[] = 'pht-cursive-headings';
		}

		return $classes;

	}

	/**
	 * Detects if current template displays sidebars and their ids.
	 *
	 * @since Yaga 1.0
	 * @return void
	 */
	public static function yaga_get_id() {

		if ( !is_singular() && !( 'page' == get_option( 'show_on_front' ) && is_home() ) ) {
			return;
		}

		self::$id = get_queried_object_id();

		if ( !self::$id ) {
			return;
		}

	}

	/**
	 * Detects if current template displays sidebars and their ids.
	 *
	 * @since Yaga 1.0
	 * @return void
	 */
	public static function yaga_pre_phtpb() {

		if ( !self::$id ) {
			return;
		}
		
		$post_type = get_post_type( self::$id );
		
		if ( !$post_type || !in_array( $post_type, PeHaaThemes_Theme_Start::$post_types_with_PHTPB ) ) {
			return;
		}

		if ( in_array( self::$id, PeHaa_Themes_Page_Builder::$phtpb_forbidden_ids ) ) {
			return;
		}

		if ( 'yes' !== get_post_meta( self::$id, PeHaa_Themes_Page_Builder::$meta_field_name_state, true ) ) {
			return;
		} 
		self::$use_phtpb = true;

	}

	/**
	 * Detects if current template displays sidebars and their ids.
	 *
	 * @since Yaga 1.0
	 * @return void
	 */
	public static function yaga_pre_sidebar() {

		self::$sidebar = Yaga_Sidebar::get_instance();

	}

	/**
	 * Adjusts the content width based on the theme's design and stylesheet.
	 *
	 * @since Yaga 1.0
	 */

	public static function yaga_adjust_content_width() {

		global $content_width;

		if ( self::$sidebar->display ) {

			$GLOBALS['content_width'] = self::$alt_custom_width;

		}

	}

	public static function yaga_default_width( $args ) {
		
		$args['width'] = self::$custom_width;
		return $args;
	}

	public static function yaga_user_footer_scripts() {

		$script = get_theme_mod( 'yaga_footer_script' );

		if ( $script ) {
			echo stripslashes( $script );
		}
			

	}

	public static function yaga_user_header_scripts() {

		$script = get_theme_mod( 'yaga_header_script' );

		if ( $script ) {
			echo stripslashes( $script );
		}
			

	}

	public static function yaga_tag_cloud_args( $args ) {

		return wp_parse_args( self::$tag_cloud_args, $args );

	}

	public static function yaga_add_image_sizes() {

		foreach ( self::$image_sizes as $image_size_name => $image_size ) {
			add_image_size( $image_size_name, $image_size['width'], $image_size['height'], $image_size['crop'] );
		}

	}

	public static function yaga_register_menus() {

		register_nav_menus( self::$menu_locations );

	}

	public static function yaga_add_media_class( $avatar ) {

		$style_class = 'visible_square' === get_theme_mod( 'yaga_avatar_display', 'visible_circle' ) ? '' : 'pht-rounded';

		return str_replace( "class='", "class='media__img $style_class ", $avatar );

	}

	public static function yaga_custom_sizes_names( $sizes ) {

		$custom_sizes = array();

		foreach ( self::$image_sizes as $image_size_name => $image_size ) {
			if ( !isset( $image_size['title'] ) ) continue;
			$custom_sizes[ $image_size_name ] = $image_size['title'];
		}
		return array_merge( $sizes, $custom_sizes );
	}

	/**
	 * Removes html { margin-top: 28px !important; } from WordPress header
	 *
	 */
	public static function yaga_remove_admin_margin_top() {
		remove_action( 'wp_head', '_admin_bar_bump_cb' );
	}

	public static function yaga_dont_do() {
		return false;
	}


	public static function yaga_load_wp_media_files() {
		wp_enqueue_media();
	}

	public static function yaga_custom_metaboxes_script( $hook ) {

		if ( $hook != 'post.php' && $hook != 'post-new.php' )
			return;

		wp_enqueue_script( 'yaga-admin-js', get_template_directory_uri() . '/js/admin.min.js' );
		
	}

	public static function yaga_load_more() {

		check_ajax_referer( self::$load_more_nonce, 'nonce' );
		
		if ( !is_numeric( $_POST['page'] ) || $_POST['page'] < 0 ) {
			die( 'Invalid page' );
		}
		if ( !isset( $_POST['template'] ) ) {
			die( 'No template set' );
		}

		// Normal archives
		$query_args = '';

		if ( isset( $_POST['archive'] ) && $_POST['archive'] ) {
			$query_args = $_POST['archive'] . '&';
		}
		$query_args .= 'post_status=publish&posts_per_page='. get_option( 'posts_per_page' ) .'&paged='. $_POST['page'];

		// Post format archives
		if ( isset( $_POST['archive'] ) && $_POST['archive'] && strlen( strstr( $_POST['archive'], 'post-format' ) ) > 0 ) {
			$query_args = array(
				'post_status' => 'publish',
				'tax_query' => array(
					array(
						'taxonomy' => 'post_format',
						'field' => 'slug',
						'terms' => $_POST['archive']
					)
				),
				'posts_per_page' => get_option( 'posts_per_page' ),
				'paged' => $_POST['page']
			);
		}

		$query = new WP_Query( $query_args );

		while ( $query->have_posts() ) : $query->the_post();
		get_template_part( $_POST['template'] );
		endwhile;

		wp_reset_postdata();

		exit;
	}

	public static function yaga_enqueue_public_scripts() {

		if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
			wp_enqueue_script( 'comment-reply' );
		}

		wp_enqueue_script( 'yaga-modernizr', get_template_directory_uri() . '/js/modernizr.custom.min.js', array(), self::$modernizr_version, false );
	
		wp_enqueue_script( 'yaga-all', get_template_directory_uri() .'/js/yaga-all.min.js', array( 'jquery', 'wp-mediaelement', 'jquery-ui-tabs', 'jquery-ui-accordion' ), PeHaaThemes_Theme_Start::$theme_version, true );
	
		$myparams = array(
			'nonce' => wp_create_nonce( self::$load_more_nonce ),
			'ajaxURL' => esc_url( admin_url( 'admin-ajax.php' ) ),
			'navigation_breakpoint' => self::$navigation_breakpoint
		);

		wp_localize_script( 'yaga-all', 'yaga_scriptparams', $myparams );

	}

	public static function yaga_custom_widgets() {

		require_once PEHAATHEMES_INCLUDES_DIR . '/class-yaga-widget.php';

		if ( class_exists( 'Yaga_Widget' ) ) {
			require_once PEHAATHEMES_INCLUDES_DIR . '/class-yaga-widget-social.php';
			require_once PEHAATHEMES_INCLUDES_DIR . '/class-yaga-widget-recent-posts.php';
			require_once PEHAATHEMES_INCLUDES_DIR . '/image-text-widget/class-yaga-widget-image-and-text.php';
			register_widget( 'Yaga_Widget_Social' );
			register_widget( 'Yaga_Widget_Recent_Posts' );
			register_widget( 'Yaga_Widget_Image_and_Text' );
		}	
	}

	public static function yaga_footer_sidebar_count( $params ) {

    	if ( isset( $params[0]['id'] ) && 'sidebar-2' === $params[0]['id'] ) {

        	$all_widgets = wp_get_sidebars_widgets();

			$my_widgets = $all_widgets['sidebar-2'];

			$my_widgets_count = count( $my_widgets );

			if (  0 === ( $my_widgets_count % 4 ) ) {
				return $params;
			}

			if ( 0 === $my_widgets_count % 3 || $my_widgets_count % 3 > $my_widgets_count % 4 ) {
				$before_widget = $params[0]['before_widget'];
				$params[0]['before_widget'] = preg_replace( '/u-1-of-4-desk u-1-of-2-lap/', 'u-1-of-3-desk u-1-of-3-lap',  $before_widget );
			}
		}

    	return $params;

	}

	public static function yaga_password_form() {
    
	    global $post;

	    $label = 'pwbox-'.( empty( $post->ID ) ? rand() : $post->ID );
	    $o = '<div class="pht-box pht-box--highlight pht-mb">';
	    $o .= '<form class="pht-mb0" action="' . esc_url( site_url( 'wp-login.php?action=postpass', 'login_post' ) ) . '" method="post">';
	    $o .= esc_html__( 'To view this protected post, enter the password below:', 'yaga' );
	    $o .= '<div><label class="pht-zeta strong" for="' . $label . '">' . esc_html__( 'Password:', 'yaga' ) . ' </label></div>';
	    $o .= '<div><input name="post_password" id="' . $label . '" type="password" size="20" maxlength="20" /> <input type="submit" class="pht-btn pht-btn--small" name="Submit" value="' . esc_attr__( 'Submit', 'yaga' ) . '" /></div>
	    </form>
	    ';
	    $o .= '</div>';
	    return $o;
	}

	public static function yaga_preloader() { 
		
		if ( ! Yaga_Site_Header::$display_preloader ) {
			return;
		}
		
		?>
		<div id="site-preloader" class="pht-preloader">
			<div class="preloader__inner"><span></span><span></span><span></span><span></span><span></span></div>
		</div>
	<?php }

	public static function yaga_pre_site_header() {
		if ( class_exists( 'Yaga_Site_Header' ) ) {
			Yaga_Site_Header::get_instance();
		}
	}

	public static function yaga_display_site_header() {
		
		if ( class_exists( 'Yaga_Site_Header' ) ) {

			$yaga_site_header = Yaga_Site_Header::get_instance();
			$yaga_site_header->header_html();

		}
		
	}

	public static function yaga_excerpt_link( $excerpt ) {
	
		global $post;
		
		$title_text = apply_filters( 'yaga_excerpt_text_string', esc_html__( 'Read more', 'yaga' ) );
	
		if ( '' !== $excerpt && !is_attachment() ) {
			
			return $excerpt . '...  <a class="pht-excerpt pht-block pht-actionfont a-a a-a--no-h" href="' . esc_url( get_permalink( $post->ID ) ) . '" title="' . esc_attr( $title_text ) .':'. esc_attr( get_the_title( $post->ID ) ) . '">' . esc_html( $title_text ) . ' &raquo;</a>';
		
		} elseif ( is_attachment()  ) {

			return $excerpt;

		} else {
			return;
		}
	}

	public static function yaga_theme_script_handler() {

		return 'yaga-all';

	}

	public static function add_editor_styles() {

		add_editor_style( 'css/editor-style.css' );
	
	}

	public static function yaga_add_styleselect_button( $buttons ) {
	
		array_unshift( $buttons, 'styleselect' );
		return $buttons;
	
	}


	public static function yaga_mce_before_init_insert_formats( $init_array ) {  
		
		$font_sizes = array(
			'pht-alpha--large' => '90px',
			'pht-beta--large' => '72px',
			'pht-gamma--large' => '60px',
			'pht-alpha' => '48px',
			'pht-epsilon--large' => '36px',
			'pht-beta' => '30px',
			'pht-gamma' => '24px',
			'pht-delta--loose' => '20px',
			'pht-epsilon' => '16px',
			'pht-zeta' => '14px',
			'pht-milli' => '13px',
			'pht-micro' => '12px',
		);
		$style_formats_sizes = array();
		foreach ( $font_sizes as $class => $title ) {
			$style_formats_sizes[] = array(
				'title' => $title,
				'selector' => 'p,h1,h2,h3,h4,h5,h6,span',
				'classes' => $class,
			);
		}

		$short_underlines = array(
			'left' => esc_html__( 'Left', 'yaga' ),
			'right' => esc_html__( 'Right', 'yaga' ),
			'center' => esc_html__( 'Center', 'yaga' ),
		);

		$style_short_underlines = array();
		foreach ( $short_underlines as $align => $title ) {
			$style_short_underlines[] = array(
				'title' => $title,
				'selector' => 'p,h1,h2,h3,h4,h5,h6',
				'classes' => "pht-shortunderline pht-shortunderline--$align",
			);
		}

		$style_formats_character_styles = array();
		$character_styles = array(
			'pht-caps-drop--3' => 'A',
			'pht-caps-drop--2' => 'A',
		);
		foreach ( $character_styles as $class => $title ) {
			$style_formats_character_styles[] = array(
				'title' => $title,
				'inline' => 'span',
				'classes' => $class,
				'wrapper' => true
			);
		}

		$style_formats = array(  
		
			array(  
				'title' => esc_html__( 'Use headings font', 'yaga' ), 
				'block' => 'span',  
				'classes' => 'pht-secondfont',
				'wrapper' => true,			
			),
			array(  
				'title' => esc_html__( 'Use body font', 'yaga' ), 
				'block' => 'span',  
				'classes' => 'firstfont',
				'wrapper' => true,			
			),
			array(
				'title' => esc_html__( 'Short Underline', 'yaga' ),
				'items' => $style_short_underlines,
			),
			array(
				'title' => esc_html__( 'Heading with Horizontal Line', 'yaga' ),
				'selector' => 'h6,h1,h2,h3,h4,h5',
				'classes' => "pht-h-hline",
			),
			array(
				'title' => esc_html__( 'Font sizes', 'yaga' ),
				'items' => $style_formats_sizes,
			),
			array(
				'title' => esc_html__( 'Drop Caps', 'yaga' ),
				'items' => $style_formats_character_styles,
			),
			array(
				'title' => esc_html__( 'Bigger letter spacing', 'yaga' ),
				'classes' => 'pht-spacedletters',
				'inline' => 'span',
				'wrapper' => true
			),
			array(
				'title' => esc_html__( 'Button', 'yaga' ),
				'classes' => 'pht-btn pht-btn__pb',
				'selector' => 'a',
			),
			array(
				'title' => esc_html__( 'Skip bottom margin', 'yaga' ),
				'classes' => 'pht-mb0',
				'selector' => 'p,h1,h2,h3,h4,h5,h6'
			)
			
		);

		$init_array['style_formats'] = json_encode( $style_formats );  
		
		return $init_array;  
	  
	}

	public static function yaga_search_form( $form ) {
		//avoid validator.w3.org warning: Element form does not need a role attribute.
		return str_replace( 'role="search"', '', $form );
	
	}

	public static function yaga_html_classes( $classes ) {

		$ml = pehaathemes_get_theme_mod_not_empty( 'yaga_ml', 'normal' );
		$navigation = self::$navigation;
		
		if ( in_array( $ml, array('normal', 'tiny', 'no' ) ) ) {
			$classes .= " pht-html--$ml-ml";
		}

		if ( in_array( $navigation, array( 'default', 'sticky_full', 'sticky_center', 'top_fixed_full', 'top_fixed_center', 'top_fixed_fixed' ) ) ) {
			$classes .= " pht--$navigation-navigation";
			if ( 'default' === $navigation ) {
				$classes .= " js-pht--default-navigation";
			} elseif ( in_array( $navigation, array( 'sticky_full', 'sticky_center' ) ) ) {
				$classes .= " pht--sticky-navigation";
			} elseif ( in_array( $navigation, array( 'top_fixed_full', 'top_fixed_center' ) ) ) {
				$classes .= " pht--top-fixed-navigation";
			}
		}		

		return $classes;
	}
}

endif;