<?php
/**
 * Adds or overrides some PeHaa Themes Page Builder modules
 *
 *
 * @package Yaga
 * @author  PeHaa THEMES <info@pehaa.com>
 */

if ( !class_exists( 'Yaga_PeHaa_Themes_Page_Builder_Shortcode_Template' ) ) :

class Yaga_PeHaa_Themes_Page_Builder_Shortcode_Template extends PeHaa_Themes_Page_Builder_Shortcode_Template {

	protected function phtpb_section() {

		$inner_div = $section_class = '';

		$bg_video = isset( $this->atts['bg_video'] ) ? esc_url( $this->atts['bg_video'] ) : '';

		$img_to_be_loaded = $this->img_to_be_loaded( $this->phtpb_id, 'force' === $this->phtpb_type );

		if ( $bg_video || $img_to_be_loaded ) {
			$parallax = $this->select_attribute( 'parallax' );
			$opacity = isset( $this->atts['opacity'] ) && ''!== trim( $this->atts['opacity'] ) ? 'opacity:' . esc_attr( $this->atts['opacity'] ) . ';' : '';		
		}

		$bg_color_style = $this->bg_color ? "style='background:$this->bg_color'" : '';
		
		$video_div = '';
		
		if ( $bg_video ) {

			$style = $opacity ? 'style="' . esc_attr( $opacity ) . '"' : '';
			$video_div .= "<div class='pht-bg-ctnr__hider pht-bg-ctnr__hider pht-bg-ctnr__hider--$parallax' $bg_color_style>";
			$video_div .= "<div class='js-initial-hidden js-video-video pht-video-ctnr hidden--palm pht-bg-ctnr js-phtpb_section_bg--$parallax phtpb_section_bg--$parallax' $style>";
			$video_attributes = apply_filters( 'yaga_phtpb_section_video_attributes', 'loop autoplay muted', $this->atts['module_id'] );
			$video_div .= '<video width="640" height="360" style="width: 100%; height: 100%;" controls="controls" preload="auto" ' . esc_attr( $video_attributes ) . '>';
			$video_div .= '<source type="video/mp4" data-src="' . esc_url( $bg_video ) . '"/>';
			$video_div .= '</video>';
			$video_div .= '</div>';
			$video_div .= '</div>';
		} 

		if ( !$bg_video && $this->phtpb_id || $bg_video && $this->phtpb_id && ( 'force' === $this->phtpb_type ) ) {

			$img = $this->image_src( $this->phtpb_id, 'full', 'phtpb_insert_section_bg_size' );
	
			if ( $img ) {
				
				$palm_class = 'force' === $this->phtpb_type ? 'js-force-palm' : 'hidden--palm';	
				$section_class .= 'force' === $this->phtpb_type ? ' phtpb_section--bg-force-palm' : ' phtpb_section--bg-hidden-palm';
				
				$style_bg_size = '';

				if ( $this->r_w || $this->r_h ) {
					
					$bg_size = $this->r_w ? $this->r_w . 'px' : 'auto';
					$bg_size .= $this->r_h ? ' ' . $this->r_w . 'px' : '';
					
					$style_bg_size = "background-size: $bg_size;";
				}
				
				$style = $style_bg_size || $opacity ? "style='$style_bg_size $opacity'" : '';
				$inner_div .= "<div class='pht-bg-ctnr__hider pht-bg-ctnr__hider--$parallax' $bg_color_style><div class='js-pht-bg-ctnr js-pht-bg-ctnr-img pht-bg-ctnr js-phtpb_section_bg--$parallax phtpb_section_bg--$parallax $palm_class js-initial-hidden' $style>";

				$inner_div .= $img_to_be_loaded;

				$inner_div .= '</div></div>';

			}
		}

		if ( $this->bg_color && !$this->phtpb_id ) {
 			$this->content= preg_replace( '/\[phtpb_gallery([^\]]+)/i', '${0} herited_color="' . esc_attr( $this->bg_color ). '"', $this->content );		
 		}

 		$layout_option = isset( $this->atts['layout_option'] ) ? esc_attr( $this->atts['layout_option'] ) : 'none';
 		$section_class .= ' phtpb_section--padding-' . $layout_option;
 		
 		if ( in_array( $layout_option, array( 'full', 'full-48', 'full-96' ) ) ) {
			$output = $inner_div . $video_div;
			$output .= '<div class="phtpb_section__in">';
			$output .= '<div class="phtpb_section__in__in">';
			$output .= do_shortcode( $this->content );
			$output .= '</div>';
			$output .= '</div>';
			$section_class .= ' js-phtpb_section--padding-full phtpb_section--full';
			$display_scrolldown = 'no' !== $this->select_attribute( 'scroll_down' );
 		} else {
 			$output = $inner_div . $video_div . do_shortcode( $this->content );
 			$display_scrolldown = 'yes' === $this->select_attribute( 'scroll_down' );
 		}
 		$output .= $display_scrolldown ? '<a href="#" class="hidden--portable js-pht-scrolldown pht-scrolldown a-a a-a--no-h"></a>' : '';
 				
		if ( ! $output ) {
			return;
		}

		$section_class .= 'inherit' === $this->phtpb_type ? ' pht-inherit-colors-palm' : '';

		return $this->container( $output, "phtpb_section pht-parent $section_class", '', 'section', array(), true, false );
	
	}

	protected function phtpb_column() {
				 
		$class = array(
			'4_4' => '',
			'1_2' => 'u-1-of-2-desk u-1-of-2-lap',
			'1_3' => 'u-1-of-3-desk u-1-of-3-lap',
			'1_4' => 'u-1-of-4-desk u-1-of-4-lap',
			'2_3' => 'u-2-of-3-desk u-2-of-3-lap',
			'3_4' => 'u-3-of-4-desk u-3-of-4-lap',
		);

		$margins = $this->is_checked( 'margins' );
		$colorbox_class = $this->module_class;
		$colorbox_class .= 'auto' === $this->select_attribute( 'z_index' ) ? '' : $this->select_attribute( 'z_index' );
		$v_align = $this->select_attribute( 'valign' );
		$colorbox_class .= $v_align ? ' pht-box--valign-' . $v_align : ' pht-box--valign-top';
		$box_class = '';

		$animation = $this->select_attribute( 'animation' );

		if ( in_array( $animation, array( 'fly', 'fade-fly' ) ) ) {
			$colorbox_class .= ' js-pht-fly pht-fly';
		}
		if ( 'fade-fly' === $animation ) {
			$animation = 'fade';
		}
		if ( 'fly' === $animation ) {
			$animation = 'none';
		}

		$colorbox_class .= 'none' === $animation ? '' : " js-pht-waypoint pht-waypoint pht-$animation";
		$colorbox_style = $this->bg_color ? 'background:' . esc_attr( $this->bg_color ) .';' : '';
		$colorbox_style .= $this->color ? 'color:' . esc_attr( $this->color ) .';' : '';

		$padding = $this->select_attribute( 'padding' );

		if ( 'none' !== $padding ) {
			$box_class .= " pht-box pht-$padding";
		}

		$border_width = $this->select_attribute( 'border_width' );
		$border_style = $this->select_attribute( 'border_style' );

		if ( $this->bg_color || ( 'none' !== $border_style && $border_width ) ) {
			
			if ( 'none' !== $border_style && $border_width ) {

				$colorbox_class .= " pht-border--$border_style pht-border--$border_width";
				if ( $margins ) {
					$colorbox_class .= ' pht-border--margins';
				}
				$border_color = $this->is_checked( 'use_border_color' ) && isset( $this->atts['border_color'] ) ? esc_attr( $this->atts['border_color'] ) : false;
				if ( $border_color ) {
					if ( $this->color && $border_color !== $this->color || !$this->color && $border_color !== PeHaa_Themes_Page_Builder::$defaults['color'] ) {
						$colorbox_style .= 'border-color:' . esc_attr( $border_color ) .';';
					}
				}
			}

			$colorbox_class .= ' pht-rounded--' . $this->select_attribute( 'border_radius' );
		}

		$move_v = isset( $this->atts['move_v'] ) && '' !== trim( $this->atts['move_v'] ) && '0' !== trim( $this->atts['move_v'] ) ? str_replace( 'px', '', esc_attr( $this->atts['move_v'] ) ).'px' : false;
		$move_h = isset( $this->atts['move_h'] ) && '' !== trim( $this->atts['move_h'] ) && '0' !== trim( $this->atts['move_h'] ) ? str_replace( 'px', '', esc_attr( $this->atts['move_h'] ) ).'px' : false;
		$width = isset( $this->atts['width'] ) && '' !== trim( $this->atts['width'] )  && '0' !== trim( $this->atts['width'] ) ? str_replace( 'px', '', esc_attr( $this->atts['width'] ) ).'px' : false;
		
		$colorbox_style .= $move_v ? ( $move_v > 0 ? 'top:' . $move_v .';' : 'margin-top:' . $move_v .';' ) : '';
		$colorbox_style .= $move_h ? 'left:' . $move_h .';' : '';
		$colorbox_style .= $width ? 'width:calc(100% + ' . $width . ');' : '';

		$layout_class = isset( $this->atts['layout'] ) && in_array( $this->atts['layout'], array_keys( $class ) ) ? $class[ $this->atts['layout'] ] : '';
		
		$matches = array();
		preg_match( '/phtpb_row_inner[^\]]+equals="yes"[^\"]+"/i', $this->content, $matches );
		if ( count( $matches ) ) {
			$layout_class .= ' pht-layout__item--wequals';
		}

		if ( '' === trim( $this->content ) ) {
			return sprintf( '--><div %1$s class="%2$s"></div><!--',
				$this->module_id,
				'pht-layout__item ' . $layout_class
			);
		}

		if ( $margins ) {
			return sprintf( '--><div %1$s class="%2$s"><div class="pht-colorbox %4$s" style="%5$s"><div class="%6$s">%3$s</div></div></div><!--',
				$this->module_id,
				'pht-layout__item ' . $layout_class,
				do_shortcode( $this->content ),
				$colorbox_class,
				$colorbox_style,
				$box_class
			);
		}

		
		return sprintf( '--><div %1$s class="%2$s"><div class="pht-colorbox %4$s" style="%5$s">%3$s</div></div><!--',
			$this->module_id,
			'pht-layout__item ' . $layout_class,
			do_shortcode( $this->content ),
			"$colorbox_class $box_class",
			$colorbox_style
		);
	
	}


	protected function phtpb_column_inner() {

		return $this->phtpb_column();

	}

	protected function phtpb_image() {

		$phtpb_id1 = isset( $this->atts['phtpb_id1'] ) ? (int) $this->atts['phtpb_id1'] : false;

		if ( !$this->phtpb_id && $phtpb_id1 ) {
			$this->phtpb_id = $phtpb_id1;
			$phtpb_id1 = false;
		}

		if ( !$this->phtpb_id ) {
			return;
		}

		if ( !wp_attachment_is_image( $this->phtpb_id ) ) {
			return;
		}

		if ( $phtpb_id1 && !wp_attachment_is_image( $phtpb_id1 ) ) {
			$phtpb_id1 = false;
		}

		$display_image1 = false;		
		
		if ( $this->is_checked( 'resize' ) || $this->d_w ) {
			
			if ( $this->r_h && !$this->r_w ) {
				$width = 0;
			} else {
				$width = $this->r_w ? intval( $this->r_w ) : intval( ( 24 + $this->content_width )*$this->phtpb_width - 24 );
			}
			
			$height = $this->r_h ? $this->r_h : 0;

			if ( $this->d_w ) {

				$resize_width = $width ? $this->d_w : ( $height ? 0 : $this->d_w );
				$resize_height = $width ? round( $this->d_w/$width * $height ) : $height;

			} else {
				$resize_width = $width;
				$resize_height = $height;
			}

			$size = array( intval( $resize_width ), intval( $resize_height ) );

		} else {
			$size = 'full';
			if ( $this->d_w ) {
				$resize_width = $this->d_w;
			}
		}

		$attr = array();

		if ( !empty( $resize_width ) && $resize_width ) {
			$attr['width'] = esc_attr( $resize_width );
		}
		if ( !empty( $resize_height ) && $resize_height ) {
			$attr['height'] = esc_attr( $resize_height );
		}

		$output1 = '';



		if ( $phtpb_id1 ) {

			$attr['class'] = 'pht-fig__img2';
			if ( $this->is_checked( 'rounded' ) ) {
				$attr['class'] .= ' pht-rounded';
			}

			$output1 = pehaathemes_get_att_img( $phtpb_id1, $size, false, $attr );

		}

		$attr['class'] = '';

		if ( $output1 ) {
			$attr['class'] = 'pht-fig__img1';		
		}
		if ( $this->is_checked( 'rounded' ) ) {
			$attr['class'] .= ' pht-rounded';
		}
		$output = '<span class="pht-fig__inner">';
		$output .= pehaathemes_get_att_img( $this->phtpb_id, $size, false, $attr );
		$output .= $output1;
		

		if ( isset( $this->atts['link_type'] ) ) {
			if ( 'url' === $this->atts['link_type'] && $this->link ) {
				$output .= sprintf( '<a href="%1$s" class="phtpb_image__link pht-fig__link pht-fig__link--main" %2$s></a>',
					esc_url( $this->link ),
					$this->target
					);
			} elseif ( 'lightbox' === $this->atts['link_type'] ) {
				$full_image = wp_get_attachment_image_src( $this->phtpb_id, apply_filters( 'phtpb_lightbox_image', 'full' ) );
				$output .= sprintf( '<a href="%1$s" class="phtpb_image__link pht-fig__link js-pht-magnific_popup pht-fig__link--main"></a>',
					esc_url( $full_image[0] )
					);
			}
		}

		$output .= '</span>';

		$h_align_class = $this->h_align ? "phtpb_image--$this->h_align" : '';
	
		return $this->container( $output, "phtpb_item phtpb_item--module phtpb_image pht-fig $h_align_class", '', 'figure' );

	}

	protected function phtpb_gallery() {

		$layout_option =  $this->select_attribute( 'layout_option' );

		if ( 'default' === $layout_option ) {
			$tiled_gallery = new Yaga_Tiled_Gallery();
			ob_start();
			$tiled_gallery->rectangular_talavera( $this->atts['phtpb_ids'], $this->phtpb_width, false, $this->lightbox  );
			$output = ob_get_contents();
			ob_end_clean();
			if ( $output ) {
				$css = $this->herited_color ? 'color:' . $this->herited_color : '';
				$class = 'phtpb_item js-pht-lightboxgallery pht-gallery phtpb_gallery pht-gallery--' . $this->select_attribute( 'border_width' );
				return $this->container( $output, $class, $css );
			}
			return;
		}

		$heights = array(
			'1c' => 0,
			'2c' => 384, 
			'3c' => $this->phtpb_width > 1 ? 384 : 240, 
			'4c' => $this->phtpb_width > 1 ? 384 : 192, 
			'5c' => $this->phtpb_width > 1 ? 384 : 1140/5, 
			'6c' => $this->phtpb_width > 1 ? 384 : 1140/6, 
			'2' => 0 , 
			'3' => 0, 
			'4' => 0, 
			'5' => 0, 
			'6' => 0,
		);
		$height =  isset( $heights[ $layout_option ] ) ? $heights[ $layout_option ] : 0;
		$column_count = (int) str_replace( 'c', '', $layout_option );
		$gutter_class = $article_layout_class = '';

		if ( $this->phtpb_width > 1 ) {		
			$width = 1 === $column_count ? 1140 : 570;
			$article_layout_class = ' u-1-of-2 u-1-of-'  . $column_count . '-desk';
		} elseif ( $this->phtpb_width >= .75 ) {
			
			if ( ! $column_count ) {
				$column_count = 3;
			}
			$width = (int) 1140/$column_count;
			$article_layout_class = ' u-1-of-2 pht-mctnr--2__item u-1-of-'  . $column_count. '-desk';
		} elseif ( $this->phtpb_width >= .5 ) {
			$width = 1 === $column_count ? 1140 : (int) 1140/3;
			$article_layout_class = 1 === $column_count ? ' u-1-of-1' : ' u-1-of-2';
		} else {
			$width = (int) 1140/4;
			$article_layout_class = ' u-1-of-1';
		}

		$skip_array = apply_filters( 'yaga_dont_resize_in_gallery', array( 'image/gif' ), $layout_option, $this->atts['module_id'] ); 
		$gutter = $this->select_attribute( 'border_width' );
		
		if ( 'none' !== $gutter ) {
			$gutter_class = ' pht-mctnr--gut' . $gutter;
			$article_layout_class .= ' pht-mctnr--gut' . $gutter .'__item';
		}
		ob_start();
		?>

		<div class="js-showcase js-phtpb_showcase_ctnr pht-white cf <?php echo esc_attr( $gutter_class ); ?>">

			<?php 
			$phtpb_post = Yaga_Entry::get_instance(); 
			foreach( explode( ',', $this->atts['phtpb_ids'] ) as $id ) { ?>
				<article class="pht-showcase__item pht-parent pht-hider js-pht-waypoint pht-waypoint pht-fadesat <?php echo esc_attr( $article_layout_class ); ?>">
					<figure class="pht-fig pht-fig--filter">
						<?php 
						echo pehaathemes_get_att_img(  $id, array( $width, $height ), false, array( 'class' => 'pht-img--fill', 'width' => $width ), $skip_array );
						if ( $this->lightbox ) { ?>
							<div class="pht-fig__link--ctnr">
								<?php printf( '<a class="pht-fig__link js-pht-magnific_popup pht-fig__link--hoverdir pht-fig__link--main pht-text-center a-a a-a--no-h" href="%1$s">', esc_url( wp_get_attachment_url( $id ) )
								); ?>
									<div class="pht-fig__titles">
										<i class="pht-fig__link__string pht-ic-f1-arrow-expand-alt pht-gamma"></i>
									</div>
								</a>
							</div>
						<?php }	?>
					</figure>
				</article>

			<?php } ?>

		</div><!-- .js-phtpb_showcase_ctnr -->

		<?php $output = ob_get_contents();

		ob_end_clean();

		return $this->container( $output, 'phtpb_item js-pht-lightboxgallery pht-gallery' );
		
		
	}

	protected function phtpb_mixed_gallery_item() {

		$layout_option =  $this->select_attribute( 'layout_option' );

		$gutter = $this->select_attribute( 'gutter' );
		
		$column_count = (int) str_replace( 'c', '', $layout_option );

		$dimensions = self::dimensions( $layout_option );

		$article_layout_class = 'u-1-of-'  . $column_count . '-desk u-1-of-'  . $column_count . '-lap';

		if ( 1 !== $column_count ) {
			$article_layout_class .= ' u-1-of-2';
		} else {
			$article_layout_class .= ' u-1-of-1';
		}

		if ( 'none' !== $gutter ) {
			$article_layout_class .= ' pht-mctnr--gut' . $gutter .'__item';
		}

		$skip_array = apply_filters( 'phtpb_dont_resize_in_gallery', array( 'image/gif' ), $layout_option, $this->atts['module_id'] );		

		$output = '<figure class="pht-fig pht-fig--filter">';
		$output .= self::get_att_img(   $this->phtpb_id, array( $dimensions['width'], $dimensions['height'] ), false, array( 'class' => 'pht-img--fill', 'width' => $dimensions['width'] ), $skip_array );
		$link_type = $this->select_attribute( 'link_type' );

		$a_opened = false;
		$span_opened = false;

			if ( 'url' === $link_type && $this->link ) {
				$output .= '<div class="pht-fig__link--ctnr">';
				$output .= "<a href='$this->link' class='pht-fig__link pht-fig__link--main pht-fig__link--hoverdir pht-text-center a-a a-a--no-h' $this->target>";
				$output .= '<span class="pht-fig__titles">';
				$output .= '<i class="pht-fig__link__str pht-parent pht-ic-f1-link pht-gamma"></i>';
				$a_opened = true;
			} elseif ( 'lightbox' === $link_type ) {
				$output .= '<div class="pht-fig__link--ctnr">';
				$output .= sprintf( '<a class="pht-fig__link pht-fig__link--main mfp-image js-pht-magnific_popup pht-fig__link--hoverdir pht-text-center a-a a-a--no-h" data-pht-mfp-title="%1$s" href="%2$s">',
						esc_attr( $this->atts['title'] ),
						esc_url( wp_get_attachment_url( $this->phtpb_id ) )
					); 
				$lightbox_icon_class = apply_filters( 'phtpb_lightbox_icon_class', 'pht-ic-f1-arrow-expand-alt' );
				$output .= '<span class="pht-fig__titles">';
				$output .= '<i class="pht-fig__link__str pht-parent ' . esc_attr( $lightbox_icon_class ) . ' pht-gamma"></i>';
				$a_opened = true;		
			} elseif ( 'lightbox_video' === $link_type &&  $this->link ) {
				$output .= '<div class="pht-fig__link--ctnr">';
				$output .= sprintf( '<a class="pht-fig__link pht-fig__link--main mfp-iframe js-pht-magnific_popup pht-fig__link--hoverdir pht-fig__link--main pht-text-center a-a a-a--no-h" data-pht-mfp-title="%1$s" href="%2$s">',
					esc_attr( $this->atts['title'] ),
					esc_url( $this->link )
				); 
				$lightbox_video_icon_class = apply_filters( 'phtpb_lightbox_video_icon_class', 'pht-ic-f1-triangle-right-alt' ); 
				$output .= '<span class="pht-fig__titles">';
				$output .= '<i class="pht-fig__link__str pht-parent ' . esc_attr( $lightbox_video_icon_class ) . ' pht-gamma"></i>';
				$a_opened = true;

			} elseif ( !$this->link && $this->atts['title'] ) {
				$output .= '<div class="pht-fig__link--ctnr">';
				$output .= sprintf( '<span class="pht-fig__link pht-fig__link--main mfp-iframe js-pht-magnific_popup pht-fig__link--hoverdir pht-fig__link--main pht-text-center">',
					esc_attr( $this->atts['title'] ),
					esc_url( $this->link )
				); 
				$output .= '<span class="pht-fig__titles">';
				$span_opened = true;
			}
			
			if ( $this->atts['title'] ) {
				$title_class =  apply_filters( 'phtpb_mixed_gallery_title_class', '' );
				$output .= sprintf( '<span class="pht-fig__link__str pht-fig__link__str--text pht-parent pht-milli hidden--small %s">%s</span>',
					esc_attr( esc_attr( $title_class ) ),
					esc_html( $this->atts['title'] ) 
				);
			}
			if ( $a_opened ) {
				$output .= '</span>';
				$output .= '</a>';
				$output .= '</div>';
			} elseif ( $span_opened ) {
				$output .= '</span>';
				$output .= '</span>';
				$output .= '</div>';
			}
			
		
		$output .= '</figure>';


		return $this->container( $output, 'pht-showcase__item pht-parent pht-hider js-pht-waypoint pht-waypoint pht-fadesat ' . esc_attr( $article_layout_class ), '', 'div', array(), true, false );

	}

	protected function phtpb_gallery_portfolio() {

		if ( !$this->phtpb_type ) {
			return;
		}

		$query_args = array(
			'post_type' => $this->phtpb_type,
			'meta_key' => '_thumbnail_id',
			'ignore_sticky_posts' => 1
		);

		if ( $this->count ) {
			$query_args['posts_per_page'] = $this->count;
		}

		$phtpb_query = isset( $this->atts['phtpb_query'] ) ? htmlspecialchars_decode( $this->atts['phtpb_query'] ) : '';

		$query_args_with_phtpb_query = wp_parse_args( $phtpb_query, $query_args );

		if ( method_exists( $this, 'remove_unallowed_query_args' ) ) {
			$query_args_with_phtpb_query = $this->remove_unallowed_query_args( $query_args_with_phtpb_query );
		}

		$query_args_with_phtpb_query['paged'] = is_front_page() ? get_query_var( 'page' ) : get_query_var( 'paged' );

		$query_args_with_phtpb_query = apply_filters( 'yaga_phtpb_gallery_portfolio_query', $query_args_with_phtpb_query, $this->atts['module_id'] );

		ob_start();

		$custom_query = new WP_Query( $query_args_with_phtpb_query );

		if ( $custom_query -> have_posts() ) :

			$post_ids = array();

			while ( $custom_query -> have_posts() ) : $custom_query ->the_post();
				$post_ids[] = get_the_id();
			endwhile;

			$tiled_gallery = new Yaga_Tiled_Gallery();
			$tiled_gallery->rectangular_talavera_of_posts( $post_ids, $this->phtpb_width, false, $this->lightbox  );

			$phtpb_post = Yaga_Entry::get_instance();
		
			if ( $this->is_checked( 'pagination' ) ) {
				$phtpb_post->pagination( $custom_query );
			}

		endif;		

		wp_reset_postdata();

		$posts = ob_get_contents();

		ob_end_clean();

		$output = $posts;
		
		$css = $this->herited_color ? 'color:' . $this->herited_color : '';
			
		return $this->container( $output, 'phtpb_item js-pht-lightboxgallery pht-gallery pht-gallery--' . $this->select_attribute( 'border_width' ), $css );

	}

	protected function phtpb_btn() {
		
		$span_content = $this->icon_string;
		$span_content .= $this->title ? '<span class="pht-btn__text" data-pht-tcontent="' . esc_attr( $this->title ) . '"><span class="pht-btn__textin">' . esc_attr( $this->title ) . '</span></span>' : '';

		if ( !$span_content ) {
			return;
		}

		$link_class = $this->module_class;
		$link_class .= $this->skip ? ' u-1-of-1-desk u-1-of-1-lap' : '';
		$link_class .= ' pht-rounded--' . $this->select_attribute( 'border_radius' );
		
		$output = sprintf( '<a href="%1$s" class="%2$s" %3$s %4$s>%5$s</a>', 
			esc_url( $this->link ),
			'pht-btn pht-btn__pb ' . esc_attr( $link_class ),
			$this->target,
			$this->color ? 'style="color:'. esc_attr( $this->color ) .'"' : '',
			$span_content
			);
		return $output;
	}

	protected function phtpb_posts() {

		if ( !isset( $this->phtpb_type ) ) {
			return;
		}

		$query_args = array(
			'post_type' => $this->phtpb_type
		);
		
		if ( $this->count ) {
			$query_args['posts_per_page'] = $this->count;
		}

		$phtpb_query = isset( $this->atts['phtpb_query'] ) ? htmlspecialchars_decode( $this->atts['phtpb_query'] ) : '';

		$query_args_with_phtpb_query = wp_parse_args( $phtpb_query, $query_args );

		if ( method_exists( $this, 'remove_unallowed_query_args' ) ) {
			$query_args_with_phtpb_query = $this->remove_unallowed_query_args( $query_args_with_phtpb_query );
		}
		
		$query_args_with_phtpb_query['paged'] = is_front_page() ? get_query_var( 'page' ) : get_query_var( 'paged' );

		$query_args_with_phtpb_query = apply_filters( 'yaga_phtpb_posts_query', $query_args_with_phtpb_query, $this->atts['module_id']);

		ob_start();

		$custom_query = new WP_Query( $query_args_with_phtpb_query );

		if ( $custom_query -> have_posts() ) :

			$grid_class = $this->masonry_grid_class();

			$yaga_post = Yaga_Entry::get_instance(); 

			?>

				<section class="phtpb_posts_grid <?php echo esc_attr( $grid_class ); ?>">

					<?php 

					while ( $custom_query -> have_posts() ) : $custom_query ->the_post();

						$yaga_post->entry( 'grid', true, true, $this->skip, '', $this->is_checked( 'fixed_height' ) ? 'yaga-post-grid-gallery' :  '' );

					endwhile; ?>

				</section>

			<?php 

			if ( $this->is_checked( 'pagination' ) ) {
				$yaga_post->pagination( $custom_query );
			}

		endif;
		
		wp_reset_postdata();

		$output = ob_get_contents();

		ob_end_clean();

		return $this->container( $output, 'phtpb_item' );
	}

	protected function phtpb_showcase() {

		$query = explode( '::', $this->phtpb_type );


		if ( 2 === count( $query ) ) {
			$post_type = $query[0];
			$taxonomy = '__' === $query[1] ? '' : $query[1];
		}	
		

		if ( empty( $post_type ) && is_int( (int) $this->phtpb_type ) ) {
			
			//legacy phtpb_type
			
			$showcases_array = Yaga_PHTPB_Addons::$showcases_array;

			if ( ! isset( $showcases_array[ $this->phtpb_type ]['item'] ) ) {
				return;
			}

			$post_type = $showcases_array[ $this->phtpb_type ]['item'];

			if ( ! isset( $showcases_array[ $this->phtpb_type ]['taxonomy'] ) ) {
				$taxonomy = '';
			} else {
				$taxonomy = $showcases_array[ $this->phtpb_type ]['taxonomy'];
			}

		}

		if ( empty( $post_type ) ) {
			return;
		}
		
		$taxonomy_array = $taxonomy ? array( $taxonomy ) : array();
		$taxonomy_array = apply_filters( 'yaga_taxonomy_filter', $taxonomy_array, $this->atts['module_id'] );
		
		$query_args = array(
			'post_type' => $post_type,
			'meta_key' => '_thumbnail_id',
			'ignore_sticky_posts' => 1
		);

		if ( $this->count ) {
			$query_args['posts_per_page'] = $this->count;
		}

		$phtpb_query = isset( $this->atts['phtpb_query'] ) ? htmlspecialchars_decode( $this->atts['phtpb_query'] ) : '';
		
		$query_args_with_phtpb_query = wp_parse_args( $phtpb_query, $query_args );

		if ( method_exists( $this, 'remove_unallowed_query_args' ) ) {
			$query_args_with_phtpb_query = $this->remove_unallowed_query_args( $query_args_with_phtpb_query );
		}

		$query_args_with_phtpb_query = apply_filters( 'yaga_phtpb_showcase_query', $query_args_with_phtpb_query, $this->atts['module_id'] );

		ob_start();
	
		$showcase_query = new WP_Query( $query_args_with_phtpb_query );
	
		if ( $showcase_query -> have_posts() ) :

			if ( count( $taxonomy_array ) ) {

				$args = array(
					'order' => apply_filters( 'yaga_taxonomy_filter_order', 'ASC', $taxonomy_array, $this->atts['module_id'] ),
					'orderby' => apply_filters( 'yaga_taxonomy_filter_orderby', 'slug', $taxonomy_array, $this->atts['module_id'] )
				);

				
				$args = apply_filters( 'yaga_taxonomy_filter_args', $args, $taxonomy_array, $this->atts['module_id'] );

				$terms = get_terms( $taxonomy_array, $args );

				printf( '<p class="pht-showcase__filters pht-actionfont pht-zeta">');
				printf( '<span class="pht-pointer js-pht-showcase-filter pht-showcase__filter pht-showcase__filter--active" data-filter="*">%s</span><!--', isset( $this->atts['all_label'] ) && '' !== trim( $this->atts['all_label'] ) ? esc_html( trim( $this->atts['all_label'] ) ) : esc_html__( 'All', 'yaga' ) );
				foreach ( $terms as $term ) {
					echo "--><span class='pht-pointer js-pht-showcase-filter pht-showcase__filter' data-filter='.$term->slug'>$term->name</span><!--"; // don't delete "."
				} 
				echo '--></p>';
			
			}

			$phtpb_post = Yaga_Entry::get_instance(); 

			$layout_option =  $this->select_attribute( 'layout_option' );
			$heights = array( 
				'2c' => 384, 
				'3c' => $this->phtpb_width > 1 ? 384 : 240, 
				'4c' => $this->phtpb_width > 1 ? 384 : 192, 
				'5c' => $this->phtpb_width > 1 ? 384 : 1140/5, 
				'6c' => $this->phtpb_width > 1 ? 384 : 1140/6, 
				'2' => 0 , 
				'3' => 0, 
				'4' => 0, 
				'5' => 0, 
				'6' => 0,
				'1' => 0
			);
			$height =  isset( $heights[ $layout_option ] ) ? $heights[ $layout_option ] : 0;
			$column_count = (int) str_replace( 'c', '', $layout_option );
			$gutter = $this->select_attribute( 'gutter' );
			$gutter_class = $article_layout_class = '';

			if ( $this->phtpb_width > 1 ) {
				$width = 570;
				$article_layout_class = ' u-1-of-2 u-1-of-'  . $column_count . '-desk';
			} elseif ( $this->phtpb_width >= .75 ) {
				
				if ( ! $column_count ) {
					$column_count = 3;
				}
				$width = (int) 1140/$column_count;
				$article_layout_class = ' u-1-of-2 pht-mctnr--2__item u-1-of-'  . $column_count. '-desk';
			} elseif ( $this->phtpb_width >= .5 ) {
				$width = (int) 1140/3;
				$article_layout_class = ' u-1-of-2';
			} else {
				$width = (int) 1140/4;
				$article_layout_class = ' u-1-of-1';
			}

			if ( 1 === $column_count ) {
				$width = (int) 1140;
				$article_layout_class = ' u-1-of-1';
			}

			if ( 'none' !== $gutter ) {
				$gutter_class = ' pht-mctnr--gut' . $gutter;
				$article_layout_class .= ' pht-mctnr--gut' . $gutter .'__item';
			}

			$skip_array = apply_filters( 'yaga_dont_resize_in_filtrable_portfolio', array( 'image/gif' ), $layout_option, $this->atts['module_id'] );
			$width = apply_filters( 'yaga_portfolio_image_width', $width, $layout_option, $this->atts['module_id'], $this->phtpb_width );
			if ( in_array( $layout_option, array( '2c', '3c', '4c', '5c', '6c', '1' ) ) ) {
				$height = apply_filters( 'yaga_portfolio_image_height', $height, $layout_option, $this->atts['module_id'] ); 
			} ?>
			
			<div class="js-showcase js-phtpb_showcase_ctnr pht-white cf <?php echo esc_attr( $gutter_class ); ?>">

				<?php while ( $showcase_query -> have_posts() ) : $showcase_query -> the_post();

					$terms_class = '';

					if ( count( $taxonomy_array ) ) {

						foreach ( $taxonomy_array as $tax ) {
							$terms_array = get_the_terms( get_the_ID(), $tax  );
							if ( $terms_array ) {
								foreach ( $terms_array as $term ) {
									$terms_class .= $term->slug.' ';
								}
							}
						}

					} ?>

					<article class="pht-showcase__item pht-parent pht-hider js-pht-waypoint pht-waypoint pht-fadesat <?php echo esc_attr( $terms_class . ' ' . $article_layout_class ); ?>"> 
						<?php
						$phtpb_post->showcase_retina_entry( get_the_ID(), get_post_thumbnail_id( get_the_ID() ), $width, $height, $skip_array, $this->lightbox ); ?>

					</article>

				<?php endwhile; ?>

			</div><!-- .js-phtpb_showcase_ctnr -->

		<?php endif;

		wp_reset_postdata();

		$output = ob_get_contents();

		ob_end_clean();

		return $this->container( $output, 'js-pht-lightboxgallery phtpb_item phtpb_item--showcase' );

	}

	protected function phtpb_revslider() {
		if ( ! class_exists( 'RevSlider' ) ) {
			return;
		}
		if ( ! $this->phtpb_id_string ) {
			return;
		}
		$content = "[rev_slider $this->phtpb_id_string]";
		return do_shortcode( $content );
	}

	private function masonry_grid_class() {

		$grid_class = 'js-pht-lightboxgallery pht-index pht-index--grid';

		if ( !$this->phtpb_width ) {
			return $grid_class;
		}
				
		if ( $this->phtpb_width > 0.4 ) {

			$grid_class .= ' phtpb_masonry_container index-isotope-unloaded';
			if ( '0.5' === $this->phtpb_width ) {
				$grid_class .= ' phtpb_masonry_container--h';
			} elseif ( 0.75 < $this->phtpb_width ) {
				$grid_class .= ' phtpb_masonry_container--f';
			} else {
				$grid_class .= $this->phtpb_width > 0.7 ? ' phtpb_masonry_container--l' : ' phtpb_masonry_container--s';
			}
			
		} else {
			$grid_class .= ' phtpb_no-masonry_container';
		}
		return $grid_class;
	}

	protected function _phtpb_img_carousel_slide( $image_id, $height, $ratio = 0 ) {

		if ( !$image_id ) {
			return;
		}

		if ( !wp_attachment_is_image( $image_id ) ) {
			return;
		}

		if ( $height ) {
			$display_image = $this->resizer->resize_image( $image_id, '' , round( $height * $ratio ), $height, true );			
		} else {
			$display_image = wp_get_attachment_image_src( $image_id, apply_filters( 'phtpb_img_carousel', 'full' ) );
		}
		$width_index =  $height ? 'width' : 1;
		$url_index =  $height ? 'url' : 0;

		$output = '<div>';
		$output .= '<figure class="pht-fig" style="width:'. $display_image[ $width_index ] . 'px">';
		$output .= sprintf( '<img src="%1$s" alt="%2$s" %3$s/>',
			$display_image[ $url_index ],
			self::image_alt(  $this->phtpb_id ), 
			$this->d_w ? 'width="' . $this->d_w .'"' : ''
		);
		
		if ( $this->lightbox ) {
			$output .= '<div class="pht-fig__link--ctnr pht-white">';
			$full_image = wp_get_attachment_image_src( $image_id, apply_filters( 'phtpb_lightbox_image', 'full' ) );
			$output .= "<a href='$full_image[0]' class='pht-fig__link--hoverdir pht-fig__link pht-fig__link--main a-a a-a--no-h'><i class='pht-fig__link__string pht-ic-f1-arrow-expand-alt pht-gamma'></i></a>";
			$output .= '</div>';
		}
		$output .= '</figure>';
		$output .= '</div>';

		return $output;
		
	}

	protected function phtpb_img_carousel_slide( $image_id, $ratio = 0 ) {

		if ( !$image_id ) {
			return;
		}

		if ( !wp_attachment_is_image( $image_id ) ) {
			return;
		}
		$width_index =  'width';
		$url_index = 'url';
		$method_name = method_exists( 'PeHaa_Themes_Page_Builder_Shortcode_Template', 'get_att_img_lazy' ) ? 'get_att_img_lazy' : 'get_att_img';
		if ( !method_exists( 'PeHaa_Themes_Page_Builder_Shortcode_Template', $method_name ) ) {
			return;
		}
		if (  $ratio ) {
			$display_image = self::$method_name( $image_id, array( round( $this->select_attribute( 'hoption' ) * $ratio ),  $this->select_attribute( 'hoption' ) ), false, array( 'height' => $this->select_attribute( 'hoption' ) ) );			
		} else if ( 'flexible' === $this->select_attribute( 'woption' ) ) {
			$display_image = self::$method_name( $image_id, array( $this->select_attribute( 'woption1' ), $this->select_attribute( 'hoption1' ) ) );
		} else {
			$display_image = self::$method_name( $image_id, array( 0, $this->select_attribute( 'hoption' ) ) );
		}
		
		$width = $this->select_attribute( 'woption1' ) ? $this->select_attribute( 'woption1' ) : $this->select_attribute( 'hoption' ) * $ratio;
		
		$output = '<div class="slick-slide">';
		$output .= '<figure class="pht-fig pht-white">';
		$output .= $display_image;
		if ( $this->lightbox ) {
			$full_image = wp_get_attachment_image_src( $image_id, apply_filters( 'phtpb_lightbox_image', 'full' ) );
			$output .= '<div class="pht-fig__link--ctnr pht-white">';
			$output .= "<a href='$full_image[0]' class='pht-fig__link--hoverdir pht-fig__link pht-fig__link--main a-a a-a--no-h'><i class='pht-fig__link__string pht-ic-f1-arrow-expand-alt pht-gamma'></i></a>";
			$output .= '</div>';
		}
		$output .= '</figure>';
		$output .= '</div>';

		return $output;
		
	}

	protected function phtpb_contact_form7() {
		
		if ( ! $this->phtpb_id ) {
			return;
		}

		global $wpdb;
			$cf7 = $wpdb->get_results(
				"
			  SELECT ID, post_title
			  FROM $wpdb->posts
			  WHERE post_type = 'wpcf7_contact_form'
			  "
		);

		if ( count( $cf7 ) ) {
			foreach ( $cf7 as $cform ) {
				$contact_forms[] = $cform->ID;
			}
		} else {
			return;
		}

		if ( !in_array( $this->phtpb_id, $contact_forms ) ) {
			$this->phtpb_id = $contact_forms[0];			
		}

		$output = do_shortcode( '[contact-form-7 id=' . $this->phtpb_id .']' );
		
		if ( $output ) {
			$class = 'phtpb_item phtpb_contact_form7';
			return $this->container(  $output, $class );
		}
		return;
		
	}

}
endif;