<?php

if ( ! class_exists( 'Yaga_Tiled_Gallery' ) ) :
class Yaga_Tiled_Gallery extends PeHaaThemes_Tiled_Gallery {

	public function rectangular_talavera_of_posts( $post_ids, $width = 1, $container = true, $fancybox = true  ) {
		
		$srcs = $new_post_ids = array();

		foreach( $post_ids as $post_id ) {
			if ( has_post_thumbnail( $post_id ) )
				$srcs[] = get_post_thumbnail_id( $post_id );
				$new_post_ids[] = $post_id;
		}
		
		$this->rectangular_talavera( $srcs, $width, $container, $fancybox, $new_post_ids );
	
	}

	public function rectangular_talavera( $srcs, $width = 1, $container = true, $fancybox = true, $post_ids = array() ) {
		
		$linked_to_posts = count( $post_ids );
		$grouper = $this->pehaathemes_talavera( $srcs, $width );
		$skip_array = apply_filters( 'pehaathemes_do_not_resize_in_gallery', array( 'image/gif' ) );

		$output = '';
		$i = 0;
		if ( $container ) { ?>
			<div class="js-pht-lightboxgallery pht-gallery">
		<?php }			
			$row_count = 0;
			foreach ( $grouper->grouped_images as $row ) {
				$row_count++;
				$row_count_class = ( 1 < $row_count ) ? 'pht-gallery__row--not1st' : '';
				$group_count = 0; 
				$padding_bottom = ( $row->height )/( $row->width )*100;
				?>
				
				<div class="pht-gallery__row" style="width:100%; padding-bottom:<?php echo esc_attr( $padding_bottom ); ?>%">
					<div class="pht-gallery__group-container">
				
					<?php
					foreach( $row->groups as $group ) {
						$group_count++;
						$item_count = 0;
						$width = ( $group->width )/( $row->width )*100;
						$padding_bottom = ( $group->height )/( $group->width )*100; ?>

						<div class="pht-gallery__group" style="width:<?php echo esc_attr( $width ); ?>%;padding-bottom:<?php echo esc_attr( $padding_bottom ); ?>%;">
					
						<?php foreach ( $group->images as $image ) {
							$item_count++;
							$item_count_class = ( 1 < $item_count || 1 < $row_count ) ? 'pht-gallery__item--not1stt' : '';
							$link_count_class = ( 1 < $item_count || 1 < $row_count ) ? ' pht-gallery__link--not1stt' : '';
							$item_count_class .= ( 1 < $group_count ) ? ' pht-gallery__item--not1stl' : '';
							$link_count_class .= ( 1 < $group_count ) ? ' pht-gallery__link--not1stl' : '';
							$size = 'large';
							if ( $image->width < 250 ) {
								$size = 'small';
							}	

							$image_title = $image->post_title;
							$orig_file = wp_get_attachment_url( $image->ID );
							$link = $this->get_attachment_link( $image->ID, $orig_file );
							$original_image = wp_get_attachment_image_src( $image->ID, 'full' );
							$original_image_url = $original_image[0];
							$figure_class = 'pht-gallery__item pht-gallery__item-' . esc_attr( $size ) . ' ' . $item_count_class; ?>
							<figure class='pht-fig <?php echo esc_attr( $figure_class ); ?>'>

								<?php $img_dimensions = array( $image->width, $image->height );
								
								echo pehaathemes_get_att_img( $image->ID, $img_dimensions, false, array( 'width' => $image->width, 'height' => $image->height ), $skip_array );

								$link_class = "pht-fig__link--main pht-fig__link--hoverdir $link_count_class";

								if ( $linked_to_posts || $fancybox ) { ?>
									<div class="pht-fig__link--ctnr pht-white">
									<?php $icon_class = 'pht-fig__link__string pht-ic-f1-arrow-expand-alt pht-gamma';
									if ( $linked_to_posts ) { ?>
										<div class="pht-fig__link--ctnr pht-white">
											<a class="pht-fig__link pht-fig__link--main pht-text-center a-a a-a--no-h <?php echo esc_attr( $link_class ); ?>" href="<?php echo esc_url( get_permalink( $post_ids[ $i ] ) ); ?>">
												<div class="pht-fig__titles">
													<h2 class="entry-title pht-truncate pht-heading hN pht-mb0 "><?php echo esc_html( get_the_title( $post_ids[ $i ] ) ); ?></h2>
												</div>
											</a>
										</div>
										<?php 
										$link_class = 'pht-fig__link--secondary';
										$icon_class .= 'pht-fig__link__string pht-ic-f1-arrow-expand-alt';
									}
									if ( $fancybox ) { ?>
										<a href="<?php echo esc_url( $orig_file ); ?>" class="pht-fig__link js-pht-magnific_popup a-a a-a--no-h <?php echo esc_attr( $link_class ); ?>">
											<i class="<?php echo esc_attr( $icon_class ); ?>"></i>
										</a>
									<?php } ?>
									</div>
								<?php }
							
							if ( !$linked_to_posts && trim( $image->post_excerpt ) ) { ?>

								<figcaption class="pht-gallery__caption pht-milli pht-transition"><?php echo wptexturize( $image->post_excerpt ) ?></figcaption>
							
							<?php }
							do_action( 'yaga_before_gallery_figure_closes', $orig_file );
							$i++; ?>
						</figure>
					<?php } ?>
					</div>
				<?php } ?>
				</div>
			</div>
		<?php }
		if ( $container ) { ?>
			</div>
		<?php }
	}
}
endif;