<?php
/**
 *
 * @package   Yaga
 * @author    PeHaa THEMES <info@pehaa.com>
 */

if ( ! class_exists( 'Yaga_Widget' ) ) :

abstract class Yaga_Widget extends WP_Widget {

	protected function yaga_before_widget( $args ) {

		if ( !isset( $args['before_widget'] ) ) {
			return;
		}

		if ( 0 === strpos( $args['before_widget'], '-->' ) ) {
			$args['before_widget'] = substr( $args['before_widget'], 3 );
			echo '-->';
		}

		echo wp_kses( $args['before_widget'], array( 'aside' => array( 'id' => array(), 'class' => array() ), 'li' => array( 'id' => array(), 'class' => array() ) ) );

	}

	protected function yaga_widget_title( $title, $args ) {

		if ( $title ) { 
			echo wp_kses( $args['before_title'], array( 'h2' => array( 'class' => array() ) ) ) . esc_html( $title ) . wp_kses( $args['after_title'], array( 'h2' => array( 'class' => array() ) ) ); 
		}
		
	}

	protected function yaga_after_widget( $args ) {

		if ( !isset( $args['after_widget'] ) ) {
			return;
		}

		$length = strlen( $args['after_widget'] );
		$extra_end = false;

		if ( $length - 4 === strpos( $args['after_widget'], '<!--' ) ) {
			$args['after_widget'] = substr( $args['after_widget'], 0, $length - 4 );
			$extra_end = true;
		}

		echo wp_kses( $args['after_widget'], array( 'aside' => array(), 'li' => array() ) );
		if ( $extra_end ) {
			echo '<!--';
		}
	}
}

endif;