<?php

add_action( 'cmb2_init', 'yaga_mb_register_user_metabox' );

if ( !function_exists( 'yaga_mb_register_user_metabox' ) ) :
/**
 * Define the metabox and field configurations.
 *
 * @param  array $meta_boxes
 * @return array
 */
function yaga_mb_register_user_metabox() {

	$prefix = PeHaaThemes_Theme_Start::$mb_prefix;
	
	$cmb_user = new_cmb2_box( array(
		'id'         => 'user_edit',
		'title'      => esc_html__( 'User Profile Metabox', 'yaga' ),
		'object_types'      => array( 'user' ),
		'show_names' => true,
	) );
	$cmb_user->add_field( array(
		'name' => esc_html__( 'Additional Author Info', 'yaga' ),
		'desc' => esc_html__( 'These links will be displayed in author\'s bio', 'yaga' ),
		'id'   => $prefix . 'user_title',
		'type' => 'title',
	) );
	$cmb_user->add_field( array(
		'name' => esc_html__( 'Facebook URL', 'yaga' ),
		'id'   => $prefix . 'facebook_url',
		'type' => 'text_url',
	) );
	$cmb_user->add_field( array(
		'name' => esc_html__( 'Twitter URL', 'yaga' ),
		'id'   => $prefix . 'twitter_url',
		'type' => 'text_url',
	) );
	$cmb_user->add_field( array(
		'name' => esc_html__( 'Google+ URL', 'yaga' ),
		'id'   => $prefix . 'googleplus_url',
		'type' => 'text_url',
	) );
	$cmb_user->add_field( array(
		'name' => esc_html__( 'Dribbble URL', 'yaga' ),
		'id'   => $prefix . 'dribbble_url',
		'type' => 'text_url',
	) );

}
endif;