<?php

if ( ! class_exists( 'Yaga_Setup' ) ) {

class Yaga_Setup {

	public static $instance = null;

	public $menu = 'yaga-setup-page';

	public $plugin_screen_hook_suffix = null;

	public $import_path;

	public $import_path_uri;

	private $installed_demo_options_field = 'yaga-setup-demo-installed';

	private $dismiss_notice_meta_field_slug = 'yaga_setup_dismissed_notice';

	public static $demo_menu_is_imported = false;

	private $demo_menu_slug = 'pht-yaga-main-menu';

	private $demo = 'demo0';

	private $all_plugins = array(

		'pht-simple-post-types' => array(
			'slug' => 'pht-simple-post-types',
			'name' => 'PeHaa Themes Simple Post Type',
			'source' => 'http://wp-plugins.pehaa.com/pht-simple-post-types/pht-simple-post-types.zip',
			'github_repo' => 'https://github.com/pehaa/pht-simple-post-types'		
		),
		'pht-page-builder' => array(
			'slug' => 'pht-page-builder',
			'name' => 'PeHaa Themes Page Builder',
			'source' => 'http://wp-plugins.pehaa.com/pht-page-builder/pht-page-builder.zip',
			'github_repo' => 'https://github.com/pehaa/pht-page-builder'
		),
		'envato-market' => array(
			'slug' => 'envato-market',
			'name' => 'Envato Market',
			'source' => 'http://wp-plugins.pehaa.com/envato-market.zip',
			'github_repo' => 'https://github.com/envato/envato-market'
		),
		'cmb2' => array(
			'slug' => 'cmb2',
			'name' => 'CMB2',
			'source' => 'repo'
		),
		'contact-form-7' => array(
			'slug' => 'contact-form-7',
			'name' => 'Contact Form 7',
			'source' => 'repo'
		),
	);

	private $demos = array();

	private function __construct() {

		$this->demos = array(
		
			'demo0' => array(
				'name' => esc_html__( 'Demo 01 (Main)', 'yaga' ),
				'description' => esc_html__( 'Main demo, contains 5 home pages and 8 portfolio layouts.', 'yaga' ),
				'plugins' => array(
					'pht-simple-post-types',
					'pht-page-builder',
					'envato-market',
					'cmb2',
					'contact-form-7',
				),
				'configs' => array( 'yaga_setup_spt_plugin_config', 'yaga_setup_pb_plugin_config' ),
				'demo_xml' => 'demo01.xml',
				'after_demo' => array(
					'front_page' => 'yagademo01-home-01',
					'blog_page' => 'yagademo01-blog',
					'navigation' => 'pht-yaga-main-menu',
					'options' => array(
						'yaga_body_normal_font_face_weight' => '300',
						'yaga_footer_copy_bg' => '#d9dadb',
						'yaga_footer_copy_color' => '#303030'
					),
				),
				'flush' => true
			),
			'demo1' => array(
				'name' => esc_html__( 'Demo 02 (The Date)', 'yaga' ),
				'description' => esc_html__( 'One page wedding site.', 'yaga' ),
				'plugins' => array(
					'pht-page-builder',
					'envato-market',
					'cmb2',
					'contact-form-7',
				),
				'configs' => array(),
				'demo_xml' => 'demo02.xml',
				'after_demo' => array(
					'front_page' => 'yagademo02-home',
					'blog_page' => 'yagademo01-blog',
					'navigation' => 'pht-yaga-main-menu-02',
					'options' => array(
						'yaga_mini_logo' => $this->image_src( 304 ),
						'yaga_body_normal_font_face_weight' => '400',
						'yaga_ml' => 'tiny',
						'yaga_search_in_nav' => '',
						'yaga_fixed_footer' => '',
						'yaga_navigation' => 'sticky_center',
						'yaga_footer_copy_bg' => '#191919',
						'yaga_footer_copy_color' => '#ffffff'
					)
				),
				'flush' => true
			),
			'demo3' => array(
				'name' => esc_html__( 'Demo 03 (Yoga)', 'yaga' ),
				'description' => esc_html__( 'One page Yoga Teacher Personal site.', 'yaga' ),
				'plugins' => array(
					'pht-page-builder',
					'envato-market',
					'cmb2',
					'contact-form-7',
				),
				'configs' => array(),
				'demo_xml' => 'demo03.xml',
				'after_demo' => array(
					'front_page' => 'yagademo03-home',
					'blog_page' => 'thoughts-by-jess',
					'navigation' => 'pht-yaga-main-menu-03',
					'options' => array(
						'yaga_hide_tagline' => '1',
						'yaga_body_font_face' => 'Playfair Display',
						'yaga_body_normal_font_face_weight' => '400',
						'yaga_headings_font_face' => 'Economica',
						'yaga_headings_font_face_weight' => '700',
						'yaga_navigation' => 'top_fixed_fixed',
						'yaga_link_color' => '#6d5a4a',
						'yaga_link_color_1' => '#998f88',
						'yaga_html_bg' => '#ffffff',
						'yaga_text_color' => '#303030',
						'yaga_main_nav_drop_bg' => '#303030',
						'yaga_main_nav_drop_color' => '#ffffff',
						'yaga_footer_bg' => '#f2ebe4',
						'yaga_footer_color' => '#303030',
						'yaga_footer_copy_bg' => '#ede6dc',
						'yaga_footer_copy_color' => '#303030',
						'yaga_box_bg' => '#f2ebe4',
						'yaga_border_bg' => '#f5f0e8',
					),
				),
				'flush' => true
			),
			'demo4' => array(
				'name' => esc_html__( 'Demo 04 (Restaurant)', 'yaga' ),
				'description' => esc_html__( 'Restaurant Page with Recipe custom post type.', 'yaga' ),
				'plugins' => array(
					'pht-page-builder',
					'pht-simple-post-types',
					'envato-market',
					'cmb2',
					'contact-form-7',
				),
				'configs' => array( 'yaga_setup_spt_plugin_config_04', 'yaga_setup_pb_plugin_config_04' ),
				'demo_xml' => 'demo04.xml',
				'after_demo' => array(
					'front_page' => 'yagademo04-home',
					'blog_page' => 'yaga-kitchen-blog',
					'navigation' => 'pht-yaga-main-menu-04',
					'options' => array(
						'yaga_hide_title' => '1',
						'yaga_hide_tagline' => '1',
						'yaga_logo' => $this->image_src( 275 ),
						'yaga_logo_height' => '130',
						'yaga_mini_logo' => $this->image_src( 318 ),
						'yaga_ml' => 'no',
						'yaga_body_font_face' => 'Open Sans',
						'yaga_body_normal_font_face_weight' => '300',
						'yaga_headings_font_face' => 'Abril Fatface',
						'yaga_headings_font_face_weight' => '400',
						'yaga_navigation' => 'top_fixed_center',
						'yaga_link_color' => '#818181',
						'yaga_link_color_1' => '#79a796',
						'yaga_html_bg' => '#f6f5f1',
						'yaga_text_color' => '#303030',
						'yaga_main_nav_drop_bg' => '#303030',
						'yaga_main_nav_drop_color' => '#ffffff',
						'yaga_footer_bg' => '#262626',
						'yaga_footer_color' => '#ffffff',
						'yaga_footer_copy_bg' => '#303030',
						'yaga_footer_copy_color' => '#ffffff',
						'yaga_box_bg' => '#ffffff',
						'yaga_border_bg' => '#ffffff',
					),
				),
				'flush' => true
			),
		);

		add_action( 'admin_menu', array( $this, 'admin_menu' ) );
		add_action( 'admin_notices', array( $this, 'notices' ) );
		add_action( 'admin_head', array( $this, 'dismiss' ) );

		$this->strings = array(
			'page_title' => sprintf( esc_html__( '%s Setup', 'yaga' ), PeHaaThemes_Theme_Start::$theme_name ),
			'menu_title' => sprintf( esc_html__( '%s Setup', 'yaga' ), PeHaaThemes_Theme_Start::$theme_name ),
		);

		add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );
		add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_styles' ) );
		add_action( 'wp_ajax_yaga_setup_plugin_installer', array( $this, 'plugin_installer' ) );
		add_action( 'wp_ajax_yaga_setup_spt_plugin_config', array( $this, 'spt_plugin_config' ) );
		add_action( 'wp_ajax_yaga_setup_pb_plugin_config', array( $this, 'pb_plugin_config' ) );
		add_action( 'wp_ajax_yaga_setup_spt_plugin_config_04', array( $this, 'spt_plugin_config_04' ) );
		add_action( 'wp_ajax_yaga_setup_pb_plugin_config_04', array( $this, 'pb_plugin_config_04' ) );
		add_action( 'wp_ajax_yaga_setup_demo_importer', array( $this, 'import_demo' ) );
		add_action( 'wp_ajax_yaga_setup_flush', array( $this, 'flush' ) );

		// Make sure things get reset on switch theme.

		add_action( 'switch_theme', array( $this, 'clean_setup' ) );
	
	}

	/**
	 * Return an instance of this class.
	 *
	 * @since     1.0.0
	 *
	 * @return    object    A single instance of this class.
	 */
	public static function get_instance() {

		if ( null == self::$instance ) {
			self::$instance = new self;
		}
		return self::$instance;
	}

	public function is_setup_complete() {
		
		$complete = array( 
			'all_plugins_installed' => true, 
			'demo_installed' => get_option( $this->installed_demo_options_field )
		);

		foreach ( $this->all_plugins as $slug => $plugin ) {
			$file_path = $this->_get_plugin_basename_from_slug( $slug );
			if ( ! is_plugin_active( $file_path ) ) {
				$complete[ 'all_plugins_installed' ] = false;
				break;
			}
		}

		return $complete;
	}

	public function admin_menu() {

		if ( ! current_user_can( 'install_plugins' ) ) {
			return;
		}

		$this->plugin_screen_hook_suffix[] = add_theme_page(
			$this->strings['page_title'],          // Page title.
			$this->strings['menu_title'],          // Menu title.
			'edit_theme_options',                  // Capability.
			$this->menu,                           // Menu slug.
			array( $this, 'setup_page' ) // Callback.
		);

	}

	public function get_setup_page_url() {
		
		$url = add_query_arg(
			array(
				'page' => urlencode( $this->menu ),
				),
			esc_url( self_admin_url( 'themes.php' ) )
		);

		return $url;
	}


	/**
		 * Check if viewing one of this plugin's admin pages.
		 *
		 * @since   1.0.0
		 *
		 * @return  bool
		 */
	private function viewing_this_plugin() {		
			
		if ( ! isset( $this->plugin_screen_hook_suffix ) ) {
			return false;
		}
			
		$screen = get_current_screen();

		if ( in_array( $screen->id, $this->plugin_screen_hook_suffix ) ) {
			return true;
		} else {
			return false;
		}
			
	}

	public function enqueue_styles() {

		if ( ! $this->viewing_this_plugin() ) {
			wp_enqueue_style( 'yaga-setup-notices', get_template_directory_uri() . '/css/admin-notices.css', array(), PeHaaThemes_Theme_Start::$theme_version, 'all' );
			return;
		}
		
		wp_enqueue_style( 'yaga-setup', get_template_directory_uri() . '/css/setup.css', array(), PeHaaThemes_Theme_Start::$theme_version, 'all' );
		
	}

	public function enqueue_scripts() {
		
		if ( ! $this->viewing_this_plugin() ) {
			return;
		}

		wp_enqueue_script( 'yaga-setup-js', get_template_directory_uri() . '/js/assets/setup.js', array( 'jquery', 'underscore' ), PeHaaThemes_Theme_Start::$theme_version );
		
		$installs = $configs = $all_plugins = array();
		foreach ( $this->all_plugins as $key => $plugin ) {
			$all_plugins[$key] = array(
				'name' => $plugin['name'],
				'slug' => $key,
				'nonce' => wp_create_nonce( "yaga-setup-install-$key" ),
			);
		}
		foreach ( $this->demos as $key => $demo ) {
			//foreach ( $demo['plugins'] as $plugin_key => $plugin ) {
				$installs[$key] = $demo['plugins'];
			//}
			foreach ( $demo['configs'] as $action ) {
				$configs[$key][] = array(
					'actionName' => $action,
					'nonce' => wp_create_nonce( $action ),
				);
			}
		}
		$myparams = array(
			'nonce_import' => wp_create_nonce( 'yaga-setup-import' ),
			'nonce_flush' => wp_create_nonce( 'yaga-setup-flush' ),
			'current_page' => esc_url( $this->get_setup_page_url() ),
			'all_plugins' => $all_plugins,
			'installs' => $installs,
			'configs' => $configs,
			'classes' => array(
				'start' => 'pht-larger pht-center js-pht-start-feedback',
				'progress' => 'pht-install-container',
				'fail' => 'pht-install-container pht-install-container--fail',
				'success' => 'pht-box pht-setup__success'
			),
			'strings' => array(
				'start' => esc_html__( 'Downloading, installing and activating plugins. Please be patient.', 'yaga' ),
				'plugins_fail' =>  esc_html__( 'Something went wrong during the installation process. Not all plugins are properly installed.', 'yaga' ),
				'plugins_configure' => esc_html__( 'Configuring plugins.', 'yaga' ),
				'importing' => esc_html__( 'Importing demo. This can take a while.', 'yaga' ),
				'importing_fail' => sprintf( wp_kses( __( 'Something went wrong. <a href="%s">Try again</a> or import demo data manually.', 'yaga' ), array( 'a' => array( 'href' => array() ) ) ), esc_url( $this->get_setup_page_url() ) ),
				'flushing' => esc_html__( 'Flushing permalinks structure.', 'yaga' ),
				'flushing_fail' =>  sprintf( wp_kses( __( 'Something went wrong while flushing permalink structure. Please <a href="%s">refresh the permalinks manually.</a>', 'yaga' ), array( 'a' => array( 'href' => array() ) ) ),  esc_url( admin_url( 'options-permalink.php' ) ) ),
				'finished' => esc_html__( 'Finished.', 'yaga' ),
				'success' => esc_html__( 'Plugin successfully installed.', 'yaga' ),
			)
		);

		wp_localize_script( 'yaga-setup-js', 'yaga_setup_scriptparams', $myparams );
	
	}

	public function setup_page() { 

		$complete = $this->is_setup_complete(); ?>

		<div class="wrap pht-setup__wrap">
			<h2><?php echo esc_html( get_admin_page_title() ); ?></h2>
			<div class="pht-setup__inner">
				<?php 

					echo '<div class="pht-box pht-setup__intro">'; 
					echo '<h3 class="pht-setup__title pht-center">' . sprintf( esc_html__( 'Welcome to the %s Setup', 'yaga' ), PeHaaThemes_Theme_Start::$theme_name )  . '</h3>';
					echo '<p class="pht-larger pht-center">' . sprintf( esc_html__( '%s ships with two PeHaa Themes plugins that enhance the theme functionality.', 'yaga' ),PeHaaThemes_Theme_Start::$theme_name ) . '</p>';
					echo '<ul class="pht-setup__list">';
					echo '<li><strong>' . esc_html__( 'PeHaa Themes Simple Post Types', 'yaga' ) . '</strong> ' . esc_html__( 'allows to easily add any custom post type (like project, recipe, destination,...).', 'yaga' ) . '</li>';
					echo '<li><strong>' . esc_html__( 'PeHaa Themes Page Builder', 'yaga' ) . '</strong> ' . esc_html__( 'replaces the editor with a simple drag-and-drop user interface allowing composing original layouts and coming with some fancy content elements. It can be activated for pages, posts and custom post types added with PeHaa Themes Simple Post Types.', 'yaga' ) . '</li>';
					echo '<li>' . sprintf( esc_html__( '%s theme uses custom metaboxes that are activated with the CMB2 plugin.', 'yaga' ), PeHaaThemes_Theme_Start::$theme_name ) . '</li>';
					echo '<li>' . sprintf( esc_html__( '%s theme demos use the Contact Form 7 plugin. We include it here.', 'yaga' ), PeHaaThemes_Theme_Start::$theme_name ) . '</li>';
					echo '<li>' . sprintf( esc_html__( 'Moreover we recommend installing WordPress Envato Market for keeping up to date with the latest version of %s theme.', 'yaga' ), PeHaaThemes_Theme_Start::$theme_name ) . '</li>';
					echo '</ul>';
					echo '</div>';

					$img_atts = array(
						'alt' => esc_attr__( 'Loading...Please wait', 'yaga' ),
						'title' => esc_attr__( 'Loading Animation Image', 'yaga' ),
						'src' => esc_url( get_template_directory_uri() ) . '/images/preloader.gif'
					);

				if ( ! $complete['demo_installed'] ) { ?>
					<div class="pht-center">
					<?php if ( ! $complete['all_plugins_installed'] ) { ?>
						<div class="pht-box">
							<a class="js-pht-setup__link pht-setup__link" id="pht-install" data-install="true" data-configure="false" data-import="false" data-reload="true"><span class="pht-transitioned"><?php esc_html_e( 'Install and Activate Plugins.', 'yaga' ); ?></span><img class="pht-setup__preloader js-pht--hidden" alt="<?php echo esc_attr( $img_atts['alt'] ); ?>" title="<?php echo esc_attr( $img_atts['title'] ); ?>" src="<?php echo esc_url( $img_atts['src'] ); ?>" width="64" height="64"></a>
						</div>
							<span class="pht-larger">or</span>
					<?php } else { ?>
						<p class="pht-box pht-setup__success"><?php printf( esc_html__( 'All recommended plugins are installed and activated. Enjoy working with %s! Thanks.', 'yaga' ), PeHaaThemes_Theme_Start::$theme_name ); ?></p>
					<?php } ?>
						<div class="pht-box">
							<h3><?php esc_html_e( 'Choose the demo version', 'yaga' ); ?></h3>
							<div class="pht-demos__items">
								
								<?php foreach ( $this->demos as $key => $demo ) { ?>
								<div class="pht-demos__item">
									<input type="radio" class="pht-demos__input" name="pehaathemes_demo_choice" id="<?php echo esc_attr( $key ); ?>" value="<?php echo esc_attr( $key ); ?>" <?php checked( 'demo0' === $key ); ?>><label for="<?php echo esc_attr( $key ); ?>"><?php echo esc_html( $demo['name'] ); ?><div><small><?php echo esc_html( $demo['description'] ); ?></small></div></label>	
								</div>
								<?php } ?>
							</div>
							<a class="js-pht-setup__link pht-setup__link" id="pht-install-importer" data-install="true" data-configure="true" data-import="true" data-reload="true">
								<span class="pht-transitioned">
									<?php if ( $complete['all_plugins_installed'] ) {
										echo esc_html__( 'Configure plugins and import the demo data.', 'yaga' );
									} else {
										echo esc_html__( 'Install + Activate Plugins and import the demo data.', 'yaga' );
									} ?>
								</span>
								<img class="pht-setup__preloader js-pht--hidden" alt="<?php echo esc_attr( $img_atts['alt'] ); ?>" title="<?php echo esc_attr( $img_atts['title'] ); ?>" src="<?php echo esc_url( $img_atts['src'] ); ?>" width="64" height="64">
							</a>
						</div>
					</div>
				<?php } else { ?>
					<div class="pht-box pht-setup__success">
						<?php 
							echo '<p>' . esc_html__( 'All recommended plugins are installed and activated.', 'yaga' ) . '</p>';
							echo '<p>' . esc_html__( 'The demo data has been imported.', 'yaga' ) . '</p>';
							echo '<p class="pht-center"><em>' . sprintf( esc_html__( 'Enjoy working with %s! Thanks.', 'yaga' ), PeHaaThemes_Theme_Start::$theme_name ) . '</em></p>';
						?>
					</div>	
				<?php }

				if ( ! $complete['demo_installed'] || ! $complete['all_plugins_installed'] ) { ?>

					<div class="pht-setup__inner">
						
						<div class="pht-feedback"></div>
					</div>
				<?php } ?>
			</div>
			<footer class="pht-box pht-setup__footer">
				<p><?php esc_html_e( 'If you need or prefer to install and activate the recommended plugins manually the links are below:', 'yaga' ); ?></p>
				<ul>
					<?php foreach ( $this->all_plugins as $key => $plugin ) { ?>
						<li><strong><?php echo esc_attr( $plugin['name'] ); ?>:</strong>
							<?php if ( 'repo' !== $plugin['source'] ) {
								echo '<a href="' . esc_url( $plugin['source'] ) . '">' . sprintf( esc_html__( '.zip file', 'yaga' ) ) . '</a>';
							} else {
								esc_html_e( 'this plugin is available in the WordPress repo', 'yaga' );
							}
							if ( isset( $plugin['github_repo'] ) ) {
								echo ' | <a href="' . esc_url( $plugin['github_repo'] ) . '">' . sprintf( esc_html__( 'GitHub Repository', 'yaga' ) ) . '</a>';
							} ?>
						</li>
					<?php } ?>
				</ul>
				<p><?php printf( esc_html__( 'If you need or prefer to import the demo data manually, the demo.xml (main demo) file can be found in the root of your %s theme folder. You can find all available demos are in the includes/setup/demos folder.', 'yaga' ), PeHaaThemes_Theme_Start::$theme_name ); ?></p>	
			</footer>
		</div>


		

	<?php }

	public function notices() { 

		if ( !current_user_can( 'install_plugins' ) || $this->viewing_this_plugin() || get_user_meta( get_current_user_id(), $this->dismiss_notice_meta_field_slug, true ) ) {
			return;
		}

		$complete = $this->is_setup_complete();

		if ( $complete['all_plugins_installed'] || $complete['demo_installed'] ) {
			return;
		}

		$string = '<div class="pht-notice pht-center">';
		$string .= '<h3 class="pht-center">' . sprintf( esc_html__( 'Welcome to %s.', 'yaga' ), PeHaaThemes_Theme_Start::$theme_name ) . '</h3>';
		$string .= '<p class="pht-notice__text">' . sprintf( esc_html__( '%s ships with two PeHaa Themes plugins that enhance the theme functionality:', 'yaga' ) . '<br />' . esc_html__( 'PeHaa Themes Page Builder and PeHaa Themes Simple Post Types.', 'yaga' ), PeHaaThemes_Theme_Start::$theme_name ) . '</p>';
		$string .= '<p>' . sprintf( esc_html__( 'Moreover we recommend installing WordPress Envato Market for keeping up to date with the latest version of %s theme.', 'yaga' ), PeHaaThemes_Theme_Start::$theme_name ) . '</p>';
		$string .= '<p class="pht-notice__text">' . esc_html__( 'We also provide a quick demo installation.', 'yaga' ) . '</p>';
		$string .= '<a href="' . esc_url( $this->get_setup_page_url() ) . '" class="pht-notice__link">' . esc_html__( 'Install Plugins/Demo Setup', 'yaga' ) . '</a> ';
		$string .= '<a href="' . esc_url( add_query_arg( 'yaga-setup-dismiss', 'dismiss_admin_notices' ) ) . '" class="pht-notice__dismiss" target="_parent">' . esc_html__( 'Dismiss this notice', 'yaga' ) . '</a>';
		$string .= '</div>';

		add_settings_error( 'yaga_setup', 'yaga_setup', $string, 'updated' );

		// Admin options pages already output settings_errors, so this is to avoid duplication.
		if ( 'options-general' !== $GLOBALS['current_screen']->parent_base ) {
			$this->display_settings_errors();
		}

	}
	/**
	 * Add dismissable admin notices.
	 *
	 * Appends a link to the admin nag messages. If clicked, the admin notice disappears and no longer is visible to users.
	 * hooked to admin_head
	 */
	public function dismiss() {
		if ( isset( $_GET['yaga-setup-dismiss'] ) ) {
			update_user_meta( get_current_user_id(), $this->dismiss_notice_meta_field_slug, 1 );
		}
	}

	/**
	 * Delete dismissable nag option for all users when theme is switched.
	 *
	 */
	private function update_dismiss() {
		delete_metadata( 'user', null, $this->dismiss_notice_meta_field_slug, null, true );
	}

	/**
	 * Display settings errors and remove those which have been displayed to avoid duplicate messages showing
	 *
	 */
	protected function display_settings_errors() {
		
		global $wp_settings_errors;

		settings_errors( 'yaga_setup' );

		foreach ( (array) $wp_settings_errors as $key => $details ) {
			if ( 'yaga_setup' === $details['setting'] ) {
				unset( $wp_settings_errors[ $key ] );
				break;
			}
		}
	}

	public function get_plugins( $plugin_folder = '' ) {
		if ( ! function_exists( 'get_plugins' ) ) {
			require_once ABSPATH . 'wp-admin/includes/plugin.php';
		}

		return get_plugins( $plugin_folder );
	}

	protected function _get_plugin_basename_from_slug( $slug ) {
		
		$keys = array_keys( $this->get_plugins() );

		foreach ( $keys as $key ) {
			if ( preg_match( '|^' . $slug . '/|', $key ) ) {
				return $key;
			}
		}

		return $slug;
	}

	public function plugin_installer() {

		if ( !isset( $_POST['plugin'] ) ) {
			return;
		}

		$plugin = $_POST['plugin'];

		check_ajax_referer( 'yaga-setup-install-' . $plugin, 'nonce' );

		if ( !isset( $this->all_plugins[ $plugin ] ) ) {
			return;
		}

		$plugin_slug = $this->all_plugins[ $plugin ]['slug']; // Plugin slug.
		$plugin_name = $this->all_plugins[ $plugin ]['name']; // Plugin name.
		$plugin_source = $this->all_plugins[ $plugin ]['source']; // Plugin source.

		if ( !isset( $plugin_slug ) || !isset( $plugin_name ) || !isset( $plugin_source ) ) {
			return;
		}
		
		$already_installed = false;

		$keys = array_keys( $this->get_plugins() );

		foreach ( $keys as $key ) {
			if ( preg_match( '|^' . $plugin .'/|', $key ) ) {
				
				if ( is_plugin_active( $key ) ) {
					wp_send_json_success( array( 'plugin' => $plugin, 'message' => esc_html__( 'Plugin already installed and activated.', 'yaga' ) ) );
				}
				$already_installed = $key;
				continue;

			}
		}
	
		require_once ABSPATH . 'wp-admin/includes/plugin-install.php'; // Need for plugins_api.
		require_once ABSPATH . 'wp-admin/includes/class-wp-upgrader.php'; // Need for upgrade classes.
		require_once PEHAATHEMES_LIBRARY_DIR .'/classes/class-pht-plugin-installer-skin.php';

		// Set plugin source to WordPress API link if available.
		if ( isset( $plugin_source ) && 'repo' == $plugin_source ) {
			
			$api = plugins_api( 'plugin_information', array( 'slug' => $plugin_slug, 'fields' => array( 'sections' => false ) ) );

			if ( is_wp_error( $api ) ) {
				 wp_send_json_error( array( 'plugin' => $plugin, 'message' => esc_html__( 'Something went wrong', 'yaga' ) ) );
			}

			if ( isset( $api->download_link ) ) {
				$plugin_source = $api->download_link;
			}
		}

		$type = preg_match( '|^http(s)?://|', $plugin_source ) ? 'web' : 'upload';
				   
		$url   = add_query_arg( array( 'action' => 'install-plugin', 'plugin' => urlencode( $plugin ) ), 'update.php' );

		$url   = esc_url_raw( $url );

		$nonce = 'install-plugin_' . $plugin;

		// Prefix a default path to pre-packaged plugins.
		$source = $plugin_source;

		// Create a new instance of Plugin_Upgrader.
		$upgrader = new Plugin_Upgrader( $skin = new PeHaaThemes_Plugin_Installer_Skin( compact( 'type', 'url', 'nonce', 'plugin', 'api' ) ) );

		// Perform the action and install the plugin from the $source urldecode().
		
		if ( ! $already_installed ) {
			
			$upgrader->install( $source );
			

		}
		// Flush plugins cache so we can make sure that the installed plugins list is always up to date.
		wp_cache_flush();
				
		if ( $already_installed ) {
			$plugin_activate = $already_installed;
		} else {
			$plugin_activate = $upgrader->plugin_info();
		}

		
		$activate = activate_plugin( $plugin_activate ); // Activate the plugin.
		wp_cache_flush();

		if ( is_wp_error( $activate ) ) {
			wp_send_json_error( array( 'plugin' => $plugin, 'message' => $activate->get_error_message() ) );
		}
		if ( $already_installed ) {
			$message = esc_html__( 'Plugin already installed. Activating.', 'yaga' );
		} else {
			$message = $skin->feedback_html;
		}
		wp_send_json_success( array( 'plugin' => $plugin, 'message' => $message, 'when' => 'end' ) );   
			
	}


	public function spt_plugin_config() {

		check_ajax_referer( 'yaga_setup_spt_plugin_config', 'nonce' );

		$plugin = 'pht_simple_post_types';

		$spt_option = get_option( 'pehaathemes_simple_post_types', array() );

		if ( array_key_exists( 'post_type', $spt_option ) ) {
			if ( array_key_exists( 'project', $spt_option['post_type'] ) ) {
				wp_send_json_success( array( 'plugin' => '', 'message' => esc_html__( 'Option already set', 'yaga' ) ) );
			} 
		} 

		$spt_option['post_type']['project'] = array(
			'name' => 'Projects',
			'singular_name' => 'Project'
		);

		$spt_option['taxonomy']['project_tag'] = array(
			'name' => 'Project Tags',
			'singular_name' => 'Project Tag',
			'object_types' => array( 'project' ),
			'hierarchical' => 'no'
		);

		$new = update_option( 'pehaathemes_simple_post_types', $spt_option );

		$this->update_option_feedback( $new, $plugin );

	}

	public function pb_plugin_config() {

		check_ajax_referer( 'yaga_setup_pb_plugin_config', 'nonce' );

		$plugin = 'pht-page-builder';

		$pb_option = get_option( 'phtpb_options', array( 'post_types' => array(), 'gmaps_api_key' => false ) );

		if ( !isset( $pb_option['post_types']['page'] ) ) {
			array_push( $pb_option['post_types'],  'page' );
		}

		if ( !isset( $pb_option['post_types']['project'] ) ) {
			array_push( $pb_option['post_types'],  'project' );
		}

		$new = update_option( 'phtpb_options', $pb_option );

		$this->update_option_feedback( $new, $plugin );


	}

	public function spt_plugin_config_04() {

		check_ajax_referer( 'yaga_setup_spt_plugin_config_04', 'nonce' );

		$plugin = 'pht_simple_post_types';

		$spt_option = get_option( 'pehaathemes_simple_post_types', array() );

		if ( array_key_exists( 'post_type', $spt_option ) ) {
			if ( array_key_exists( 'recipe', $spt_option['post_type'] ) ) {
				wp_send_json_success( array( 'plugin' => '', 'message' => esc_html__( 'Option already set', 'yaga' ) ) );
			} 
		} 

		$spt_option['post_type']['recipe'] = array(
			'name' => 'Recipes',
			'singular_name' => 'Recipe'
		);

		$spt_option['taxonomy']['chef'] = array(
			'name' => 'Chefs',
			'singular_name' => 'Chef',
			'object_types' => array( 'recipe' ),
			'hierarchical' => 'no'
		);

		$new = update_option( 'pehaathemes_simple_post_types', $spt_option );

		$this->update_option_feedback( $new, $plugin );

	}

	public function pb_plugin_config_04() {

		check_ajax_referer( 'yaga_setup_pb_plugin_config_04', 'nonce' );

		$plugin = 'pht-page-builder';

		$pb_option = get_option( 'phtpb_options', array( 'post_types' => array(), 'gmaps_api_key' => false ) );

		if ( !isset( $pb_option['post_types']['page'] ) ) {
			array_push( $pb_option['post_types'], 'page' );
		}

		if ( !isset( $pb_option['post_types']['recipe'] ) ) {
			array_push( $pb_option['post_types'], 'recipe' );
		}

		$new = update_option( 'phtpb_options', $pb_option );

		$this->update_option_feedback( $new, $plugin );


	}

	public function import_demo() {

		check_ajax_referer( 'yaga-setup-import', 'nonce' );

		if ( !empty( $_POST['demo'] ) && isset( $this->demos[ $_POST['demo'] ] ) ) {

			$nav_menus = get_terms( 'nav_menu', array( 'hide_empty' => true ) );
			if ( is_array( $nav_menus ) ) {
				foreach ( $nav_menus as $nav_menu ) {
					if ( $this->demos[$_POST['demo']]['after_demo']['navigation'] === $nav_menu->slug ) {
						self::$demo_menu_is_imported = true;
						continue;
					}
				}
			} 
		}
	
		require_once PEHAATHEMES_LIBRARY_DIR . '/wordpress-importer/wordpress-importer.php';
	
		if ( class_exists( 'WP_Importer' ) ) {

			if ( isset( $_POST['demo'] ) && isset( $this->demos[ $_POST['demo'] ] ) ) {
				$demo = $_POST['demo'];
				if ( isset( $this->demos[ $demo ]['demo_xml'] ) ) {
					$this->import_path = get_template_directory(). '/includes/setup/demos/' . $this->demos[ $demo ]['demo_xml'];
					$this->import_path_uri = get_template_directory_uri(). '/includes/setup/demos/' . $this->demos[ $demo ]['demo_xml'];
				}
			}

			$importer = new PeHaaThemes_Import;
			$importer->import( $this->import_path, $this->import_path_uri );
			wp_send_json_success( array( 'message' => $importer->feedback_html ) );

		} else {

			wp_send_json_error( array( 'message' => 'Importer class does not exist' ) );

		}
	}

	public function flush() {

		//if got here means demo was installed
		 $this->config_after_import();

		check_ajax_referer( 'yaga-setup-flush', 'nonce' );

		flush_rewrite_rules();
	
	}

	private function config_after_import() {

		update_option( $this->installed_demo_options_field, true );

		if ( isset( $_POST['demo'] ) && isset( $this->demos[ $_POST['demo'] ] ) ) {
			$this->demo = $_POST['demo'];
		}

		$this->set_front_page();

		$this->set_blog_page();

		$this->set_navigation();

		$this->set_other_options();

	}

	private function set_front_page() {

		if ( isset( $this->demos[ $this->demo ]['after_demo']['front_page'] ) && $this->demos[ $this->demo ]['after_demo']['front_page'] ) {
			$front_page = get_page_by_path( $this->demos[ $this->demo ]['after_demo']['front_page'] );
			if ( $front_page ) {
				update_option( 'show_on_front', 'page' );
				update_option( 'page_on_front', $front_page->ID );
			}
		}

	}

	private function set_blog_page() {

		if ( isset( $this->demos[ $this->demo ]['after_demo']['blog_page'] ) && $this->demos[ $this->demo ]['after_demo']['blog_page'] ) {
			$blog_page = get_page_by_path( $this->demos[ $this->demo ]['after_demo']['blog_page'] );
			if ( $blog_page ) {
				update_option( 'page_for_posts', $blog_page->ID );
			}
		}

	}

	private function set_navigation() {

		if ( isset( $this->demos[ $this->demo ]['after_demo']['navigation'] ) && $this->demos[ $this->demo ]['after_demo']['navigation'] ) {
			$locations = get_theme_mod( 'nav_menu_locations' );
			$locations['main_navigation'] = $this->demos[ $this->demo ]['after_demo']['navigation'];
			set_theme_mod( 'nav_menu_locations', $locations );
		}

	}

	private function set_other_options() {

		$mods_to_delete = array( 
			'yaga_hide_title',
			'yaga_hide_tagline',
			'yaga_logo',
			'yaga_logo_height',
			'yaga_mini_logo',
			'yaga_ml',
			'yaga_body_font_face',
			'yaga_body_normal_font_face_weight',
			'yaga_headings_font_face',
			'yaga_headings_font_face_weight',
			'yaga_navigation',
			'yaga_link_color',
			'yaga_link_color_1',
			'yaga_html_bg',
			'yaga_text_color',
			'yaga_main_nav_drop_bg',
			'yaga_main_nav_drop_color',
			'yaga_footer_bg',
			'yaga_footer_color',
			'yaga_footer_copy_bg',
			'yaga_footer_copy_color',
			'yaga_box_bg',
			'yaga_border_bg',
		);

		if ( isset( $this->demos[ $this->demo ]['after_demo']['options'] ) && is_array( $this->demos[ $this->demo ]['after_demo']['options'] ) ) {
			foreach ( $mods_to_delete as $key ) {
				remove_theme_mod( $key );
			}

			foreach ( $this->demos[ $this->demo ]['after_demo']['options'] as $key => $value ) {
				set_theme_mod( $key, $value );
			}
		}		

	}


	private function update_option_feedback( $result = true, $plugin ) {

		if ( $result ) {
			wp_send_json_success( array( 'plugin' => $plugin, 'message' => esc_html__( 'Option set.', 'yaga' ) ) );
		}

		wp_send_json_error( array( 'plugin' => $plugin, 'message' => esc_html__( 'Option not updated.', 'yaga' ) ) );

	}

	/**
	 * Flushes the plugins cache on theme switch to prevent stale entries
	 * from remaining in the plugin table.
	 *
	 */
	private function flush_plugins_cache( $clear_update_cache = true ) {
		wp_clean_plugins_cache( $clear_update_cache );
	}

	private function delete_demo_option() {
		delete_option( $this->installed_demo_options_field );
	}

	public function clean_setup() {

		$this->update_dismiss();
		$this->delete_demo_option();
		$this->flush_plugins_cache();
	}

	private function image_src( $id ) {
		
		$img = wp_get_attachment_image_src( $id, 'full' );

		if ( $img ) {
			return $img[0];
		}

		return false;
	}

}

}