/**
 * Yaga WP Template
 * -----------
 *
 * author: PeHaa THEMES
 * email: info@pehaa.com
 *
 **/

var yaga;

jQuery(document).ready(function ($) {

	"use strict";

	yaga = {
		yaga_params: yaga_scriptparams,
		lastScrollY : $( window ).scrollTop(),
		windowHeight: $( window ).height(),
		touch: Modernizr.touchevents,
		palmDeviceScreen: Modernizr.mq( "only screen and (max-device-width: 799px)" ),
		isDevice: navigator.userAgent.match( /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/ ),	
		ticking : false,
		siteHeader: $( ".js-pht--default-navigation #masthead" ),
		smallScreenQuery: "only screen and (max-width: 799px)",
		smallScreen: Modernizr.mq("only screen and (max-width: 799px)"),
		deskUpQuery: "only screen and (min-width:1024px)",
		deskUp: Modernizr.mq( "only screen and (min-width:1024px)" ),
		deskWideUpQuery: "only screen and (min-width:1280px)",
		deskWideUp : Modernizr.mq( "only screen and (min-width:1280px)" ),
		maybeFullMenu : Modernizr.mq( "screen and (min-device-width: 1280px)" ) || Modernizr.mq( "screen and (min-device-height: 1280px)" ),
		videos: [],
		videoWrap: false,
		videoRatio: 16 / 9,
		isotopeActive : {
			indexContainer : false,
			indexDo : Modernizr.mq( "screen and (min-device-width: 800px)" ) || Modernizr.mq( "screen and (min-device-height: 800px)" ),
		},
		fly : $( '.js-pht-fly' ),
		scrolledSectionBg : $( '.js-phtpb_section_bg--parallax' ),
		backToTop : $( "#pht-back-to-top" ),
		hoverDirActive : false,
		toggleSelector: ".js-toggle-trigger",
		menuToggleId: "#pht-mega-menu-toggle",
		menuToggle: $( "#pht-mega-menu-toggle" ),
		searchToggle : $( '.search-toggle a'),
		marieLouise : {
			option : 'full',
			span : 160,
			border : 24,
			borderWide : 32,
		},
		navigationOption : 'default',
		navigation : $( '#pht-main-nav__ctnr' ),

		/************************************************************/
		
		init: function () {

			var self = this;
			self.start();
			$( window ).bind( "resize", function () {
				self.resize();	
			} );

		},

		/************************************************************/

		preloader : function() {

			var self = this,
				doLoad = function() {

					if ( window.location.hash ) { 
						self.scrollToTarget( window.location.hash, 0 ); 
					}
		
					$( ".js-unloaded" )
						.removeClass( "js-unloaded" )
						.addClass( "js-loaded" );
						
					self.activateWaypoints();
					if ( $.fn.clearScroll ) {

						self.scrolledSectionBg.clearScroll().scrollMe( 0.8, 200, 180 );
						self.fly.clearScroll().scrollMe2();
					}
				};

			if ( !self.isotopeActive.indexDo ) {
				doLoad();
				return;
			}

			$( '.js-content, #colophon.site-footer--fixed' ).imagesLoaded( function() {} )
				.always( function() {
					$( '#colophon-height' ).css( 'height', $( '#colophon.site-footer--fixed' ).height()+'px' );
					
					$( '.js-phtpb_section--padding-full' ).each(function( index, elem ) {
						var span = self.marieLouise.span; 
						
						if ( 0 === index && $('body').is( '.js-body--nopageheader' ) ) {
							span = span + 120; //2*32 + 120 + 2*3*16;
						} 
						if ( $( elem ).find( '.phtpb_section__in__in' ).height() > self.windowHeight - span ) {
							$( elem ).addClass( 'pht-height-auto' );
						}
					});
					setTimeout( doLoad, 600 );
					setTimeout( function() { $( "#site-preloader" ).remove(); }, 2000 );
					
				});

		},

		/************************************************************/

		resize : function() {

			var self = this;
			
			self.windowHeight = $( window ).height();
			self.smallScreen  = Modernizr.mq( self.smallScreenQuery );
			self.deskWideUp = Modernizr.mq( self.deskWideUpQuery ),
			self.deskUp = Modernizr.mq( self.deskUpQuery );
			
			self.setBackground( '.js-pht-bg-ctnr-img' );
			
			Waypoint.refreshAll();
			self.scrolledSectionBg.clearScroll().scrollMe( 0.8, 200, 180 );
			self.fly.clearScroll().scrollMe2();
			
			if ( self.deskUp && !self.hoverDirActive ) {
				
				$('.pht-fig').hoverdir( "rebuild", {speed: 600, hoverElem: '.pht-fig__link--ctnr'});
				self.hoverDirActive = true;

			} else if ( !self.deskUp && self.hoverDirActive ) {
				
				$('.pht-fig').hoverdir( "destroy" );
				self.hoverDirActive = false;
			}

			$( '#colophon-height' ).css( 'height', $( '#colophon' ).height()+'px' );

			if ( self.maybeFullMenu ) {

				if ( !self.deskWideUp && $( 'html' ).is('.mobile-menu-closed') ) {
					if ( 'default' === self.navigationOption ) {
						$( 'body' ).removeClass( 'pht-full-menu' ).addClass( 'pht-minified-menu' );
					} else {
						$( 'body' ).addClass( 'pht-minified-menu' ).removeClass('pht-full-menu');
						$( 'html' ).removeClass( 'pht-search-active pht-html-sticky-fixed' );
						self.navigation.removeClass( 'pht-sticky-fixed' );
					}
					self.menuToggle.addClass( 'pht-toggle--closed' ).removeClass( 'pht-toggle--opened' );
					if (  self.searchToggle.is('.active') ) {
						self.searchToggle.removeClass('active');
						$( '.search-form__wrapper' ).addClass( 'search-form__wrapper--hidden' ).removeClass( 'search-form__wrapper--opened' );
						self.navigation.removeClass( 'pht-opened' ).addClass( 'pht-closed' );
					}
				} else if ( self.deskWideUp && 'default' !== self.navigationOption ) {
					if ( $( 'body' ).is( '.pht-minified-menu' ) ) {
						$( 'body' ).removeClass( 'pht-minified-menu' ).addClass('pht-full-menu');
						$( '.search-form__wrapper' ).addClass( 'search-form__wrapper--hidden' ).removeClass( 'search-form__wrapper--opened' );
						$( '.search-toggle a').removeClass('active');
						$( 'html' ).removeClass( 'pht-search-active' );
					}
					$( 'html' ).removeClass( 'mobile-menu-opened' ).addClass('mobile-menu-closed');
					
				} else if ( !self.deskWideUp && 'default' !== self.navigationOption ) {
					
					$( 'html' ).addClass( 'mobile-menu-opened' ).removeClass('mobile-menu-closed pht-html-sticky-fixed');
					$( 'body' ).addClass( 'pht-minified-menu' ).removeClass('pht-full-menu');
					self.navigation.removeClass( 'pht-sticky-fixed' );
				}
			}

			$( '.js-phtpb_section--padding-full' ).each(function( index, elem ) {
				
				var span = self.marieLouise.span;
						
				if ( 0 === index && $('body').is( '.js-body--nopageheader' ) ) {
					span = span + 120; //2*32 + 120 + 2*3*16;
				} 
				if ( $( elem ).find( '.phtpb_section__in__in' ).height() > self.windowHeight - span ) {
					$( elem ).addClass( 'pht-height-auto' );
				} else {
					$( elem ).removeClass( 'pht-height-auto' );
				}
			});
			
		},

		/************************************************************/
	
		start : function() {

			var self = this, $html = $('html');
			if ( parseInt( yaga_scriptparams.navigation_breakpoint ) >= 1024 ) {
				self.deskWideUpQuery = "only screen and (min-width:"+parseInt( yaga_scriptparams.navigation_breakpoint )+"px)";
				self.maybeFullMenu = Modernizr.mq( "screen and (min-device-width:"+parseInt( yaga_scriptparams.navigation_breakpoint )+"px)" ) || Modernizr.mq( "screen and (min-device-height:"+parseInt( yaga_scriptparams.navigation_breakpoint )+"px)" );
			}
			self.deskWideUp = Modernizr.mq( self.deskWideUpQuery );

			if ( $html.is('.pht--side-navigation') ) {
				self.navigationOption = 'side';
			}
			if ( $html.is('.pht--sticky-navigation') ) {
				self.navigationOption = 'sticky';
			}
			if ( $html.is('.pht--top-fixed-navigation') ) {
				self.navigationOption = 'top_fixed';
			} if ( $html.is('.pht--top_fixed_fixed-navigation') ) {
				self.navigationOption = 'top_fixed_fixed';
			}

			if ( $html.is('.pht-html--tiny-ml') ) {
				self.marieLouise.option = 'tiny';
				self.marieLouise.span = 120;
				self.marieLouise.border = 12;
				self.marieLouise.borderWide = 12;
			} else if ( $html.is('.pht-html--no-ml') ) {
				self.marieLouise.option = 'none';
				self.marieLouise.span = 96;
				self.marieLouise.border = 0;
				self.marieLouise.borderWide = 0;
			}
			
			self.preloader();
			self.setBackground( '.js-pht-bg-ctnr-img' );
			self.loadMore();
			self.activateInternalLinks();
			self.scrollEffects();
			self.siteNavigation();
			self.doIsotope();
			self.addVideo();
			self.addToggle();
			self.addSliders();
			self.openGallery();
			self.activateSearch();
			self.toggleComments();
			self.activateTabs();
			self.activateAccordion();
			self.activateHoverDir();
			self.doCountDown();

			$( '.js-phtpb_section--padding-full' ).each(function( index, elem ) {
				
				var span = self.marieLouise.span;
						
				if ( 0 === index && $('body').is( '.js-body--nopageheader' ) ) {
					span = span + 120; //2*32 + 120 + 2*3*16;
				} 
				if ( $( elem ).find( '.phtpb_section__in__in' ).height() > self.windowHeight - span ) {
					$( elem ).addClass( 'pht-height-auto' );
				} else {
					$( elem ).removeClass( 'pht-height-auto' );
				}
			});
								
		},

		/************************************************************/

		scrollEffects : function() {

			var self = this,
			
			scroll_handler_ticker = function () {
				if ( self.lastScrollY == $( window ).scrollTop() ) {
				} else {
					self.lastScrollY = $( window ).scrollTop();
					requestTick();
				}				
			},

			requestTick = function () {
				if ( !self.ticking ) {
					
					requestAnimationFrame( scroll_handler_af );
					self.ticking = true;
				}
			},

			scroll_handler_af = function () {

				self.scrolledSectionBg.scrollMe( 0.8, 200, 180 );
				self.fly.scrollMe2();
				self.ticking = false;

			},

			initScrollHandler_af = function () {

				if ( self.deskUp ) {
					scroll_handler_af();
					$( window ).bind( "scroll", scroll_handler_ticker );
				} else {
					$( window ).unbind( "scroll", scroll_handler_ticker );
				}
				
			};

			$.fn.extend({
				clearScroll : function() {
					return this.each(function() {
						if ( this.initiatedScroll ) {
							this.initiatedScroll = false;	
						}				
					});
				}

			});

			$.fn.extend({
				scrollMe : function( c, limitValue, A ) {
					return this.each(function() {
						if ( !this.initiatedScroll ) {
							var top = $(this).parent().offset().top,
								h = parseInt($(this).parent().css('height')),
								m = Math.min(top, self.windowHeight)+h;
		
							this.b = A + c*A*( - top - h )/m,
							this.a = c * A/m;
							this.initiatedScroll = true;
							
						}
						var position = Math.min( Math.max( -limitValue, Math.round( this.b + this.a*( self.lastScrollY ) ) ), limitValue );
						$( this ).css( 'transform', 'translate3d(0,'+position+'px, 0)' );
					});
				}

			});


			
			$.fn.extend({
				scrollMe2 : function() {
					return this.each(function() {
						if ( !this.initiatedScroll ) {
							var top = $(this).parents( '.phtpb_section' ).offset().top,
								TOP = $(this).offset().top,
								h = parseInt($(this).parents( '.phtpb_section' ).css('height')),
								s0 = Math.max(0, TOP - self.windowHeight),
								s1 = Math.max(top, self.windowHeight)+h,
								hh = parseInt($(this).css('height')),
								A = h - hh - (TOP - top );
							this.b = -s0*A/(s1-s0);
							this.a = A/(s1-s0);
							this.initiatedScroll = true;
							this.limit = A - 48;
						
						}
						var position = Math.min( Math.max( 0, Math.round( this.b + this.a*( self.lastScrollY ) ) ), this.limit );
						$( this ).css( 'transform', 'translate3d(0,'+position+'px, 0)' );
						
					});
				}

			});
			
			initScrollHandler_af();
			$( window ).bind( "resize", function () {
				initScrollHandler_af();
			});
		
		},

		/************************************************************/

		activateInternalLinks : function() {

			var self = this,
				scrollTop;

			$( 'a[href^="#"]' ).on( "touchstart click" , function( e ) {

				if ( $( this ).hasClass( "ui-tabs-anchor" ) ) {
					return;
				}				

				var target = this.hash;

				if ( '' === target ) {

					return;
				}

				e.preventDefault();

				var $target = $( target );

				if ( self.deskWideUp && 'default' !== self.navigationOption ) {
					scrollTop = $target.offset().top - 64 + parseInt($('html').css('border-top-width'));
				} else {
					scrollTop = $target.offset().top;
				}

				$( 'html, body' )
					.stop()
					.animate( {
						'scrollTop': scrollTop
						}, 800, 'swing', function () {
							if ( '#body' !== target ) {
								window.location.hash = target;
							}
						});
				
			});

		},

		/************************************************************/

		activateWaypoints : function () {
			
			var self = this;

			if ( $.fn.waypoint ) {
				
				$( '.js-content .js-pht-waypoint' ).waypoint( {
					offset: '90%',
					handler: function( ) {
						$( this.element ).addClass( 'pht-animated' );	
					}
				});

				$( 'body' ).waypoint( {
					offset: '-600px',
					handler : function( direction ) {
						if ( 'down' == direction ) {
							self.backToTop.addClass( 'pht-visible' );
						} else {
							self.backToTop.removeClass( 'pht-visible' );
						}
					}
				});

				self.siteHeader.waypoint( {
					offset: '32px',
					handler: function( direction ) {
						if ( !self.deskWideUp  ) {
							return false;
						}
						self.menuToggle.removeClass( 'pht-toggle--closed' ).addClass( 'pht-toggle--opened' );
						self.navigation.removeClass( 'pht-closed' ).addClass( 'pht-opened' );
					}
				});

				self.siteHeader.waypoint( {
					offset: '-1px',
					handler: function( direction ) {
						
						if ( !self.deskWideUp ) {
							return false;
						}

						if ( 'down' == direction ) {
							if ( !$( 'body' ).is( '.pht-minified-menu' ) && !self.searchToggle.is( '.active' ) ) {
								self.navigation.addClass( 'pht-closed' ).removeClass( 'pht-opened' );
								self.menuToggle.addClass( 'pht-toggle--closed' ).removeClass( 'pht-toggle--opened' );
							}
							$( 'body').addClass( 'pht-scrolled-down' ).removeClass('pht-not-scrolled');
						} else {
							if ( ! $( 'body').is('.pht-minified-menu' ) ) {
								self.menuToggle.removeClass( 'pht-toggle--closed' ).addClass( 'pht-toggle--opened' );
								self.navigation.removeClass( 'pht-closed' ).addClass( 'pht-opened' );
							} else {
								$( 'body').removeClass( 'pht-minified-menu' ).addClass( 'pht-full-menu' );
								self.menuToggle.removeClass( 'pht-toggle--closed' ).addClass( 'pht-toggle--opened' );
								self.navigation.removeClass( 'pht-closed' ).addClass( 'pht-opened' );
							}
							$( 'body').removeClass( 'pht-scrolled-down' ).addClass('pht-not-scrolled');
						}
					}
				});

				$( '#page' ).waypoint( {
					offset: 'bottom-in-view',
					handler: function( direction ) {						
						$( '#colophon' ).css( 'opacity', 1 )
							.find( '.js-pht-waypoint' )
							.addClass( 'pht-animated' );	
					}
				});

				$( '.pht--sticky-navigation body' ).waypoint( {
					offset: '-200',
					handler: function( direction ) {
						if ( !self.deskWideUp ) {
							return;
						}
						if ( 'down' === direction ) {
							self.navigation.addClass( 'pht-sticky-pre-fixed' );
							$( '#masthead' ).css( 'z-index', '99999' );
						} else {
							self.navigation.removeClass( 'pht-sticky-pre-fixed' );
							$( '#masthead' ).css( 'z-index', '300' );
						}		
					}
				});

				$( '.pht--sticky-navigation body' ).waypoint( {
					offset: '-400',
					handler: function( direction ) {
						if ( !self.deskWideUp ) {
							return;
						}
						if ( 'down' === direction ) {
							self.navigation.addClass( 'pht-sticky-fixed' );
							$( 'html' ).addClass( 'pht-html-sticky-fixed' );
						} else {
							self.navigation.removeClass( 'pht-sticky-fixed' );
							$( 'html' ).removeClass( 'pht-html-sticky-fixed' );
						}		
					}
				});

				$( '.pht--top-fixed-navigation body' ).waypoint( {
					offset: '-200',
					handler: function( direction ) {

						if ( 'down' === direction ) {
							self.navigation.addClass( 'pht-top-fixed-pre-fixed' );
							
						} else {
							self.navigation.removeClass( 'pht-top-fixed-pre-fixed' );
							
						}		
					}
				});

				$( '.pht--top-fixed-navigation body' ).waypoint( {
					offset: '-400',
					handler: function( direction ) {

						if ( 'down' === direction ) {
							self.navigation.addClass( 'pht-top-fixed-fixed' );
							
						} else {
							self.navigation.removeClass( 'pht-top-fixed-fixed' );
							
						}		
					}
				});

				$( '#content-and-sidebar-area' ).waypoint( {
					offset: 'bottom-in-view',
					handler: function( direction ) {
						if ( $('body').is('.pht-not-scrolled') ) {
							return;
						}
						if ( 'down' === direction ) {
							$( '.post-navigation--sticky' ).addClass( 'invisible--desk' );
						} else {
							$( '.post-navigation--sticky' ).removeClass( 'invisible--desk' );
						}		
					}
				});
			}
		},

		/************************************************************/

		activateTabs : function () {
			$('.phtpb_tabs').tabs();
		},

		/************************************************************/

		activateAccordion : function () {

			$( '.phtpb_accordion' ).each( function() {
				var collapsible = $( this ).data( 'collapsible' ),
					active = 'off' === $( this ).data( 'toggle-state' ) ? 
					false : 
					0;
				$( this ).accordion({
					header: ".js-pht-tab-header",
					collapsible: collapsible,
					active: active,
					heightStyle: "content",
					icons: { "header": "pht-ic-f1-arrow-expand", "activeHeader": "pht-ic-f1-arrow-condense" }
				});
			});
		},

		/************************************************************/

		siteNavigation : function () {

			var self = this;

			setTimeout( function() {
				if ( self.deskWideUp ) {
					if ( 'default' === self.navigationOption ) {
						$( '.pht-not-scrolled' ).removeClass( 'pht-minified-menu' ).addClass( 'pht-full-menu' );
					} else {
						$( '.pht-not-scrolled' ).removeClass( 'pht-minified-menu' ).addClass( 'pht-full-menu' );
					}
					self.navigation.addClass('pht-opened');
				}
			}, 100 );

			$( ".js-pht-scrolldown" ).on( "touchstart click", function( event ) {
				
				event.preventDefault();

				var scrollTop = $(this).parents('.phtpb_section').next().offset().top;

				if ( self.deskWideUp && 'default' !== self.navigationOption ) {
					scrollTop = scrollTop - 64 + parseInt($('html').css('border-top-width'));
				}

				$( 'html, body' )
					.stop()
					.animate( {
						'scrollTop': scrollTop
						}, 900, 'swing' );
					return false;
			});

			$( self.menuToggleId ).on( "touchstart click", function( event ) {
				
				event.preventDefault();
				
				var open = !$( this ).is( '.pht-toggle--opened' );

				if ( open ) {
					$( this ).addClass( 'pht-toggle--opened' ).removeClass( 'pht-toggle--closed ' );
				} else {
					$( this ).addClass( 'pht-toggle--closed' ).removeClass( 'pht-toggle--opened ' );
				}

				if ( !( self.deskWideUp ) ) {

					if ( open ) {
						self.searchToggle.addClass( 'active' );
						$( '.search-form__wrapper' ).removeClass( 'search-form__wrapper--hidden' ).addClass( 'search-form__wrapper--opened' );
						self.navigation.removeClass( 'pht-closed main-nav__ctnr-m-closed' ).addClass( 'pht-opened main-nav__ctnr-m-opened' );
						$( 'html' ).addClass( 'mobile-menu-opened').removeClass( 'mobile-menu-closed' );

					} else {
						self.searchToggle.removeClass( 'active' );
						$( '.search-form__wrapper' ).addClass( 'search-form__wrapper--hidden' ).removeClass( 'search-form__wrapper--opened' );
						self.navigation.addClass( 'pht-closed main-nav__ctnr-m-closed' ).removeClass( 'pht-opened main-nav__ctnr-m-opened' );
						

						setTimeout( function(){
							$( 'html' ).removeClass( 'mobile-menu-opened').addClass( 'mobile-menu-closed' );
						}, 500 );
					}

					return;
				}

				if ( open ) {
					if ( $( 'body').is( '.pht-not-scrolled' ) ) {
						$( 'body' ).removeClass( 'pht-minified-menu' ).addClass( 'pht-full-menu' );
						self.navigation.removeClass( 'pht-closed' ).addClass( 'pht-opened' );
					} else {
						$( 'html' ).addClass( 'mobile-menu-opened').removeClass( 'mobile-menu-closed' );

						$( 'body' ).addClass( 'pht-minified-menu' ).removeClass( 'pht-full-menu' );
						setTimeout( function(){
							self.navigation.removeClass( 'main-nav__ctnr-m-closed pht-closed' ).addClass( 'main-nav__ctnr-m-opened pht-opened' );
						}, 50 );
						
						self.searchToggle.trigger( 'click' );	
					}

					return;

				} else { // close
					$( 'html' ).removeClass( 'mobile-menu-opened').addClass( 'mobile-menu-closed' );
					if ( $( 'body').is( '.pht-not-scrolled' ) ) {
						if ( $( 'body').is( '.pht-minified-menu' ) ) {
							self.searchToggle.trigger( 'click' );
							self.navigation.addClass( 'pht-closed' ).removeClass( 'pht-opened' );
							return;
						}
						if ( self.searchToggle.is( '.active' ) ) {
							self.searchToggle.trigger( 'click' );
							$( this ).toggleClass( 'pht-toggle--closed pht-toggle--opened' );
							return;
						}
						self.navigation.addClass( 'pht-closed' ).removeClass( 'pht-opened' );
						
					} else {
						
						self.navigation.addClass( 'pht-closed' ).removeClass( 'pht-opened' );
						self.searchToggle.trigger( 'click' );
						
					}
					return;
				}

			});

			$( ".main-nav__a" ).on( 'touchstart.mainNav click.mainNav', function( event ) {
				
				event.stopPropagation();				
				
				var $target = $( event.target ), to, scrollTop, distance;

				if ( $target.is('a') && !$target.is( '.main-nav__icon--right') && !$target.is( '.pht-ic-f1-search' ) ) {
				
					if ( typeof( $target[0].href ) !== 'undefined' && (location.pathname.replace(/^\//,'') == this.pathname.replace(/^\//,'') && location.hostname == this.hostname) ) {

						to = $( this.hash );

						if ( to.length ) {
							
							if ( $( 'body').is( '.js-body--nopageheader' ) && 0 === $( '.phtpb_section' ).index( to ) ) {
								scrollTop = 0;
							} else {
								if ( self.deskWideUp && 'default' !== self.navigationOption ) {
									scrollTop = to.offset().top - 64 + parseInt($('html').css('border-top-width'));
								} else {
									scrollTop = to.offset().top;
								}
								
							}
							distance = Math.abs( scrollTop - self.lastScrollY );
							if ( !( 0 === scrollTop && 0 === distance ) ) {
								self.menuToggle.trigger( "click" );								
							}
							$( 'html,body' ).animate( {
								scrollTop: scrollTop
								}, Math.min( 900, distance ) );
							return false;
						
						} else {
							if ( "touchstart" === event.type ) {
								$( this ).off( "click.mainNav" );
							}
						}
					}		
				}
			});

			$( ".js-with-submenu" ).on( "touchstart click", function( event ) {

				event.stopPropagation();
				var $target = $( event.target );
				if ( $target.is( '.main-nav__icon--right' ) ) {
					$( this ).toggleClass( 'ul-hidden ul-activate' );
					event.preventDefault();
					return false;
				}
			});
		
		},

		/************************************************************/

		activateSearch : function() {

			var self = this;

			self.searchToggle.on( "touchstart click", function( event ) {

				event.preventDefault();

				var that = $( this ),
					wrapper = $( '.search-form__wrapper' );

				that.toggleClass( 'active' );
				wrapper.toggleClass( 'search-form__wrapper--hidden' ).toggleClass( 'search-form__wrapper--opened' );

				if ( that.is( '.active' ) || $( '.search-toggle .screen-reader-text' )[0] === event.target ) {
					wrapper.find( '.search-field' ).focus();
					if ( 'default' !== self.navigationOption ) {
						$('html').addClass('pht-search-active');
						self.menuToggle.addClass( 'pht-toggle--opened' ).removeClass( 'pht-toggle--closed' );
					}
				} else if ( 'default' !== self.navigationOption ) {
					$('html').removeClass('pht-search-active');
					self.menuToggle.removeClass( 'pht-toggle--opened' ).addClass( 'pht-toggle--closed' );
				}
			
			} );
		
		},

		/************************************************************/	
		
		openGallery: function () {
			

			$( ".phtpb_slicks--img" ).each( function() { // the containers for all your galleries
				$(this).magnificPopup({
					delegate: ".slick-slide a", // the selector for gallery item
					type: 'image',
					gallery: {
						enabled:true
					}
				});
			});

			
			$( '.js-pht-lightboxgallery, .phtpb_image, .js-showcase, .pht-gallery' ).each( function() {
				if ( $( this ).parents( '.js-pht-lightboxgallery' ).length ) {
					return;
				}
				$( this ).magnificPopup( {
					delegate: '.js-pht-magnific_popup',
					type: 'image',
					gallery: {
						enabled:true
					},
					callbacks: {					
						markupParse: function(template, values, item) {
							values.title = item.el.attr('data-pht-mfp-title') ? item.el.attr('data-pht-mfp-title') : item.el.attr('title');
						}						
					},
					iframe: {
						markup: '<div class="mfp-iframe-scaler">'+
									'<div class="mfp-close"></div>'+
									'<iframe class="mfp-iframe" frameborder="0" allowfullscreen></iframe>'+
									'<div class="mfp-bottom-bar">'+
										'<div class="mfp-title"></div>'+
										'<div class="mfp-counter"></div>'+
									'</div>'+
								'</div>',
						patterns: {
							youtube: {
								index: 'youtube.com/',
								id: 'v=',
								src: '//www.youtube.com/embed/%id%?autoplay=1' 
							},
							youtube1: {
								index: 'youtu.be/',
								id: '/', 
								src: '//www.youtube.com/embed/%id%?autoplay=1' 
							},
							vimeo: {
								index: 'vimeo.com/',
								id: '/',
								src: '//player.vimeo.com/video/%id%?autoplay=1'
							},
							gmaps: {
								index: '//maps.google.',
								src: '%id%&output=embed'
							}
						},
						srcAction: 'iframe_src'
					}
				});
			});
		
			$( document ).on( 'click', '.js-pht-magnific_popup, .phtpb_slicks--img a', function() {
				var $this = $(this);
				$this.parents('.pht-fig__link--ctnr').css('display','none').css( 'left', 0).css( 'top', 0 );
				setTimeout( function(){
					$this.parents('.pht-fig__link--ctnr').css('display','none').css( 'left', 0).css( 'top', 0 );
				}, 250 ); 
			});
		},

		/************************************************************/
		
		setBackground: function( selector ) {
			
			var self = this;

			$( selector ).each( function( index, elem ) {
				if ('loaded' === $( elem ).data( 'bgimage' ) ) { 
					return; 
				}
				if ( self.smallScreen && !$(elem).is('.js-force-palm') && !$(elem).parent().is('.js-force-palm') ) { 
					return; 
				}
				var $loader = $( elem ).find( '.js-pht-img-loader' ), 
					src = self.palmDeviceScreen ? 
					( $loader.data('imgurl-palm') ?
						$loader.data('imgurl-palm') :
						$loader.data('imgurl') ) :
					$loader.data('imgurl');

				if ( !src )  {
					return;
				}
				if ( !$loader.is( 'img' ) ) {
					$loader.html( '<img src="' + src + '">' );
				} 
				$( elem ).imagesLoaded( function() {} )
					.always( function( instance ) { $loader.remove(); } )
					.done( function( instance ){						
						$( elem ).css( 'background-image', 'url('+src+')').removeClass( 'js-initial-hidden' );
						$( elem ).data( 'bgimage', 'loaded' );
					}); 
			});
			
		},

		/************************************************************/

		addCommentsScript: function () {

			var opened = false;

			$( "#reply-title" ).addClass( "js-toggle-trigger" );

			$( ".comment-reply-link" ).click( function () {

				if ( !opened ) {
					
					opened = true;
					$( "#reply-title" ).removeClass( "js-toggle-trigger" )
						.next()
						.show();
				}

			} );

			$( "#cancel-comment-reply-link" ).click( function () {

				$( "#reply-title" ).addClass( "js-toggle-trigger" );
				opened = false;
				
			} );

		},

		/************************************************************/

		addSliders: function () {

			var self = this;

			$( '.phtpb_slicks--img' ).each( function( index, element ) {

				var autoplay = true === $( element ).data( 'auto' ),
					dots = true === $( element ).data( 'dots' ),
					prevArrow = false === $( element ).data( 'arrows' ) ? false : '<div data-role="none" class="phtpb_slicks--img__btn phtpb_slicks__btn phtpb_slicks__btn--prev pht-pointer" aria-label="previous"></div>',
					nextArrow = false === $( element ).data( 'arrows' ) ? false : '<div data-role="none" class="phtpb_slicks--img__btn phtpb_slicks__btn phtpb_slicks__btn--next pht-pointer" aria-label="next"></div>';
				
				$( element ).slick( {
					autoplay: autoplay,
					dots: dots,
					prevArrow: prevArrow,
					nextArrow: nextArrow,
					infinite: true,
					autoplaySpeed : $( element ).data( 'autoplayspeed' ) ? $( element ).data( 'autoplayspeed' ) : 3000,
					speed : $( element ).data( 'speed' ) ? $( element ).data( 'speed' ) : 300,
					slidesToShow:  $( element ).data( 'slidestoshow' ),
					slidesToScroll:  $( element ).data( 'slidestoscroll' ) ? $( element ).data( 'slidestoscroll' ) : 1,
					centerMode: 'variable' === $( element ).data( 'variablewidth' ),
					variableWidth: 'fixed' !== $( element ).data( 'variablewidth' ),
					centerPadding : 0,
					lazyLoad: 'ondemand',
					responsive: [
						{
							breakpoint: 800,
							settings: {
								slidesToShow: 1,
								slidesToScroll:1,
								variableWidth: false,
								centerMode: false,
								adaptiveHeight: false,
							}
						}
					]
				});
			});

			$( '.phtpb_slicks--c' ).each( function( index, element ) {
				var autoplay = true === $( element ).data( 'auto' ),
					fade = true === $( element ).data( 'fade' ),
					dots = true === $( element ).data( 'dots' ),
					prevArrow = false === $( element ).data( 'arrows' ) ? false : '<div data-role="none" class="phtpb_slicks--c__btn phtpb_slicks__btn phtpb_slicks__btn--prev pht-pointer" aria-label="previous"></div>',
					nextArrow = false === $( element ).data( 'arrows' ) ? false : '<div data-role="none" class="phtpb_slicks--c__btn phtpb_slicks__btn phtpb_slicks__btn--next pht-pointer" aria-label="next"></div>';
				$( element ).slick( {
					prevArrow: prevArrow,
					nextArrow: nextArrow,
					autoplay: autoplay,
					dots: dots,
					fade : fade,
					autoplaySpeed : $( element ).data( 'autoplayspeed' ) ? $( element ).data( 'autoplayspeed' ) : 3000,
					speed : $( element ).data( 'speed' ) ? $( element ).data( 'speed' ) : 500
				});
			});
			
			$( '.js-carousel' ).each( function( index, element ) {
				
				var dots = $( this ).data( 'dots' );
				$( element ).slick( {
					prevArrow: '<div data-role="none" class="posts-carousel__button posts-carousel__button--prev pht-pointer pht-ic-f1-arrow-left" aria-label="previous"></div>',
					nextArrow: '<div data-role="none" class="posts-carousel__button posts-carousel__button--next pht-ic-f1-arrow-right" aria-label="next"></div>',
					slidesToShow: 5,
					slidesToScroll: 5,
					infinite: false,
					dots: dots,
					responsive: [
						{
							breakpoint: 1920,
							settings: {
								slidesToShow: 4,
								slidesToScroll: 4,
							}
						},
						{
							breakpoint: 1440,
							settings: {
								slidesToShow: 3,
								slidesToScroll: 3,
							}
						},
						{
							breakpoint: 960,
							settings: {
								slidesToShow: 2,
								slidesToScroll: 2,
							}
						},
						{
							breakpoint: 480,
							settings: {
								slidesToShow: 1,
								slidesToScroll: 1,
							}
						}
					]
				});
			});

			$('.phtpb_flexslider').each( function( index, element )  {

				var $elem = $( element );

				$elem.imagesLoaded( function(){
					$elem.flexslider({
						namespace: "pht-flex-",
						animation: $elem.data('anim'),
						slideshow: $elem.data('slideshow'),
						slideshowSpeed: $elem.data('slideshowspeed') ? $elem.data('slideshowspeed') : 7000,
						animationSpeed: $elem.data('animationspeed') ? $elem.data('animationspeed') : 600,
						initDelay: $elem.data('initdelay') ? $elem.data('initdelay') : 0,
						randomize : $elem.data('randomize') ? true : false,
						fadeFirstSlide : typeof $elem.data('fadefirstslide') != 'undefined' && !$elem.data('fadefirstslide') ? false : true,
						controlNav: false,
						directionNav : typeof $elem.data('directionnav') != 'undefined' && !$elem.data('directionnav') ? false : true,
						smoothHeight:false,
						useCSS: 'fade' === $elem.data('anim'),
						prevText: "",
						nextText: "",
						animationLoop: 'fade' === $elem.data('anim') || $elem.data('slideshow'),
						start: function( slider ) {
							
							setTimeout( function() {
								$( slider )
								.addClass( 'phtpb_flexslider--loaded' )
								.find( '.pht-flex-active-slide .phtpb_flexslider__caption')
								.addClass( 'phtpb_flexslider__caption--active' );
							},600);

						},
						before: function( slider ) {
							
							$( slider )
								.find( '.pht-flex-active-slide .phtpb_flexslider__caption')
								.removeClass('phtpb_flexslider__caption--active');
						},
						after: function( slider ) {
							
							$( slider )
								.find( '.pht-flex-active-slide .phtpb_flexslider__caption')
								.addClass('phtpb_flexslider__caption--active');
						},
					});
				});
			});

			
		},
		
		/************************************************************/

		doIsotope: function () {

			var self = this,
				$indexContainer,
				$showcase;

			if ( ! self.isotopeActive.indexDo ) {
				$('.js-index-isotope-preloader').remove();
			}
			
			if ( self.isotopeActive.indexDo ) {	
				
				
				$indexContainer = $( '.index-isotope, .phtpb_masonry_container' );
				
				if ( $indexContainer.length ) {

					$indexContainer.imagesLoaded( function() {
						
						$indexContainer.isotope( { itemSelector:'article' }  );
						self.isotopeActive.indexContainer = true;
						
						var $preloader = $($(this)[0].elements[0]).find('.js-index-isotope-preloader');
						$preloader.remove();
						
						if ( $( 'body' ).is( '.js-with-preloader' ) ) {
							$indexContainer.removeClass( 'index-isotope-unloaded' );
							setTimeout( function() {
								Waypoint.refreshAll();
								self.scrolledSectionBg.clearScroll().scrollMe( 0.8, 200, 180 );
								self.fly.clearScroll().scrollMe2();
							}, 500 );
						} else {

							setTimeout( function() {
								$indexContainer.removeClass( 'index-isotope-unloaded' );
								Waypoint.refreshAll();
								self.scrolledSectionBg.clearScroll().scrollMe( 0.8, 200, 180 );
								self.fly.clearScroll().scrollMe2();
							}, 500 );

						}
				
						$indexContainer.isotope( 'bindResize' );

					});
				}
				$(window).bind( "resize", function () {

					if ( !Modernizr.mq( "screen and (min-width: 800px)" ) && self.isotopeActive.indexContainer ) {
						$indexContainer.isotope( "destroy" );
						self.isotopeActive.indexContainer = false;
					} else if ( !self.isotopeActive.indexContainer ) {
						$indexContainer.isotope( { itemSelector:'article' } );
						self.isotopeActive.indexContainer = true;
					}
					
				});

			}
			
			$showcase = $( '.js-phtpb_showcase_ctnr').isotope( {
				itemSelector: 'article, .pht-showcase__item'
			});
			
			$showcase.isotope( 'bindResize' );
			$showcase.imagesLoaded( function() {
				
				$showcase.isotope( 'layout' );
				
			});
			$showcase.isotope( 'on', 'layoutComplete', function() {
					
				if ( $.fn.waypoint ) {
					setTimeout( function() {
						Waypoint.refreshAll();
						self.scrolledSectionBg.clearScroll().scrollMe( 0.8, 200, 180 );
						self.fly.clearScroll().scrollMe2();
					}, 500 );						
				}
			});

			$( ".js-pht-showcase-filter" ).on( "touchstart click",  function ( event ) {

				event.stopPropagation();
				event.preventDefault();

				if ( !$( this ).hasClass( "pht-showcase__filter--active" ) ) {
					
					var selector = $( this ).attr( "data-filter" );
					
					$( this ).parent().next()
						.find( ".pht-fadesat" ).removeClass( "pht-fadesat" )
						.end()
						.isotope( {
							filter: selector
						});
					$( this )
						.parent()
						.find( ".pht-showcase__filter--active" )
						.removeClass( "pht-showcase__filter--active" );
					
					$( this ).addClass( "pht-showcase__filter--active" );
				}
			});
			
		},

		scrollToTarget : function( target, speed ) {


				if ( '' === target ) {
					return;
				}

				var self = this, $target = $( target ), scrollTop;

				if ( $target.length < 1 ) {
					return;
				}

				if ( self.deskWideUp && 'default' !== self.navigationOption ) {
					scrollTop = $target.offset().top - 64 + parseInt($('html').css('border-top-width'));
				} else {
					scrollTop = $target.offset().top;
				}

				if ( !self.deskUp ) {
					speed = 0;
				}

				$( 'html, body' )
					.stop()
					.animate( {
						'scrollTop': scrollTop
						}, speed, 'swing', function () {
							if ( '#body' !== target ) {
								window.location.hash = target;
							}
						});

		},

		/************************************************************/

		addVideo: function () {
			
			var self = this;
			$( 'body' ).fitVids();
			
			if ( !self.isDevice ) {

				$( '.js-video-video' ).each( function( index, element ){
					var $jsvideo = $( this ),
						$source = $jsvideo.find( 'source' ),
						src = $source.attr( "data-src" ),
						$video = $jsvideo.find( 'video' );

					$source.attr( "src", src );
					$video.attr( "id", "js-video--"+index );
					$jsvideo.parents( '.phtpb_section' ).attr( "data-video", index );
					$video.mediaelementplayer( {
						stretching: 'none',
						pauseOtherPlayers: false,
						success: function (media, node, player) {
							var ratio = self.videoRatio;
							media.addEventListener( 'loadeddata', function () {
								ratio = node.videoWidth / node.videoHeight;
								self.videoWrap = $jsvideo.find( ".mejs-container" );
								self.resizeVideo( self.videoWrap, ratio );

								$( window ).bind( 'resize', function () {
									self.resizeVideo( self.videoWrap, ratio );
								});
							}, false );

							media.addEventListener( 'canplay', function () {
								setTimeout( function() {
									$jsvideo.removeClass('js-initial-hidden');
								}, 1500 );
							});
						}
					});
				});
							
			} else {
				$( '.js-video-video' ).parent().remove();
			}
		},

		/************************************************************/

		resizeVideo: function ( selector, ratio ) {

			var self = this,
				containerH = selector.parents( '.js-video-video' ).height(),
				containerW = selector.parents( '.js-video-video' ).width();

			if ( containerW / containerH > ratio ) {
				selector.css( {
					top: -(containerW / ratio - containerH) / 2 + 'px',
					left: 0,
					width: containerW + 'px',
					height: containerW / ratio,
				} );
				selector.find('video').css( {
					width: containerW + 'px',
					height: containerW / ratio
				} );
			} else {
				selector.css( {
					width: containerH * ratio,
					height: containerH,
					top: 0,
					left: -(containerH * ratio - containerW) / 2 + 'px'
				} );
				selector.find('video').css( {
					width: containerH * ratio,
					height: containerH	
				} );
			}
		},

		/************************************************************/

		addToggle: function () {
			
			var self = this;

			$( self.toggleSelector ).on( "touchstart click" , function ( event ) {

				event.preventDefault();
				
				var selector = $( this ).data( "to-toggle" ),
					container = $( this ).data( "toggle-container" );
				
				$( this )
					.toggleClass( "active" )
					.find( ".icon-toggle" )
					.toggleClass( "js-hidden" )
					.end()
					.parents( container )
						.toggleClass( "js-opened" );
				
				$( selector ).slideToggle( 500 );

				return false;

			});

			if ( "#respond" === window.location.hash || "#comments" === window.location.hash ) {

				$( "#comments" )
					.find( self.toggleSelector )
					.trigger( "click" );
			}
			
			
		},

		/************************************************************/

		toggleComments: function () {

			var self = this,
				$comments = $( '#comments' );

			$( "#js-comments-link" ).on( "touchstart click", function( event ) {

				event.preventDefault();

				$( "body" ).stop().animate( {
					scrollTop: $comments.offset().top - 96
					}, 500, function() {
						if ( !$comments.hasClass( "js-opened" ) ) {
							$comments
								.find( self.toggleSelector )
								.trigger( "click" );
						}					
				});
			});

		},

		/************************************************************/

		doCountDown: function () {

			var self = this;

			var count = function ( display ) {
			
				setTimeout(function () {
					requestAnimationFrame( function(){ count( display ); } );
					var now = new Date();

					$( '.js-phtpb_timer--' + display ).each( function( index, element ) {
						var secondsDiff = Math.floor( ( $(element).data('counter-date')*1000 - now.getTime() ) / 1000),
						time = [],
						items = [ 'days', 'hours', 'mins', 'secs' ],
						quit_condition = 'since' === display ? ( secondsDiff > 0 ) : ( secondsDiff < 0 ),
						$container = $(element).parent();



						if ( quit_condition ) {
							$(element).removeClass( 'js-phtpb_timer--' + display );
							$container.removeClass( 'js-phtpb_countdown-activated' );
							return;
						}

						time.secs = secondsDiff;
						time.mins = Math.floor( time.secs / 60 );
						time.hours = Math.floor( time.mins / 60 );
						time.days = Math.floor( time.hours / 24 );
						time.hours %= 24;
						time.mins %= 60;
						time.secs %= 60;

						items.forEach( function( el ) {
							
							var selector = '.js-phtpb_' + el;
							$(element).find( selector ).html( Math.abs( time[ el ] ) );

						});
						if ( !$container.is( '.js-phtpb_countdown-activated' ) ) {
							$container.addClass( 'js-phtpb_countdown-activated' );
						}
					});
				}, 1000);
			};

			count( 'since' );
			count( 'until' );

		},

		/************************************************************/

		loadMore: function () {

			var self = this,
				load_more = $( '#load-more' ),
				orig_text = load_more.text(),
				archive = load_more.attr( 'data-query' ),
				maxPages = load_more.attr( 'data-maxpage' ),
				template = load_more.attr( 'data-template' ),
				page = load_more.attr( 'data-currentpage' );
			
			load_more.click( function () {
				page++;
				load_more.addClass('js-is-loading');
				$.post(
					self.yaga_params.ajaxURL, {
						action: 'yaga_load_more',
						nonce: self.yaga_params.nonce,
						page: page,
						archive: archive,
						template: template
					},
					function (html) {
						
						var $content = $(html),
						$loadinto = $(".js-loadmore-into");
						var settings = {};

						if ( typeof _wpmejsSettings !== 'undefined' ) {
							settings = _wpmejsSettings;
						}

						settings.success = settings.success || function (mejs) {
							var autoplay, loop;

							if ( 'flash' === mejs.pluginType ) {
								autoplay = mejs.attributes.autoplay && 'false' !== mejs.attributes.autoplay;
								loop = mejs.attributes.loop && 'false' !== mejs.attributes.loop;

								autoplay && mejs.addEventListener( 'canplay', function () {
									mejs.play();
								}, false );

								loop && mejs.addEventListener( 'ended', function () {
									mejs.play();
								}, false );
							}
						};
					
						$content.find( '.wp-audio-shortcode' ).mediaelementplayer( settings );
						
						$content.imagesLoaded( function () {
							$content.fitVids();			
							$content.find( '.index-gallery-flexslider' ).flexslider( {
								slideshow: false,
								prevText: "",
								nextText: "",
								controlNav: false,
							} ); 
					
							if ( self.isotopeActive.indexContainer ) {
								$loadinto.isotope( 'insert', $content );
								
							} else {
								$loadinto.append( $content );	
							}
							load_more.removeClass( 'js-is-loading' );
						});

						if (page >= maxPages) {
							load_more
								.parents( 'nav' )
								.fadeOut();
						}
					}); 
				return false;
			});
		},

		/************************************************************/

		activateHoverDir : function() {

			var self = this;

			if ( self.deskUp ) {
				$('.pht-fig').hoverdir({
					speed: 600,
					hoverElem : '.pht-fig__link--ctnr'
				});
				self.hoverDirActive = true;
			}

		}
	};
	
// http://paulirish.com/2011/requestanimationframe-for-smart-animating/
// http://my.opera.com/emoller/blog/2011/12/20/requestanimationframe-for-smart-er-animating 
// requestAnimationFrame polyfill by Erik Möller
// fixes from Paul Irish and Tino Zijdel
(function () {
	var lastTime = 0;
	var vendors = ['ms', 'moz', 'webkit', 'o'];
	for (var x = 0; x < vendors.length && !window.requestAnimationFrame; ++x) {
		window.requestAnimationFrame = window[vendors[x] + 'RequestAnimationFrame'];
		window.cancelAnimationFrame = window[vendors[x] + 'CancelAnimationFrame'] || window[vendors[x] + 'CancelRequestAnimationFrame'];
	}

	if (!window.requestAnimationFrame) {
		window.requestAnimationFrame = function (callback, element) {
			var currTime = new Date().getTime();
			var timeToCall = Math.max(0, 16 - (currTime - lastTime));
			var id = window.setTimeout(function () {
				callback(currTime + timeToCall);
			},
		timeToCall);
		lastTime = currTime + timeToCall;
		return id;
		};
	}

	if (!window.cancelAnimationFrame) {
		window.cancelAnimationFrame = function (id) {
			clearTimeout(id);
		};
	}
}());

	yaga.init();

});

(function( $ ) {
	'use strict';

$( window ).load(function() {

	function loadScript() {
		if ( !$('.phtpb_map-canvas').length ) return;
		var script = document.createElement('script');
		script.type = 'text/javascript';
		script.src = phtpb_data.gmaps_url;
		document.body.appendChild(script);
	}

	loadScript();

});

window.phtpb_initialize = function() {

	var map = {},
		myOptions = {},
		styleSettings = {};

		styleSettings.darkgreys = [{"featureType":"all","elementType":"labels.text.fill","stylers":[{"saturation":36},{"color":"#000000"},{"lightness":40}]},{"featureType":"all","elementType":"labels.text.stroke","stylers":[{"visibility":"on"},{"color":"#000000"},{"lightness":16}]},{"featureType":"all","elementType":"labels.icon","stylers":[{"visibility":"off"}]},{"featureType":"administrative","elementType":"geometry.fill","stylers":[{"color":"#000000"},{"lightness":20}]},{"featureType":"administrative","elementType":"geometry.stroke","stylers":[{"color":"#000000"},{"lightness":17},{"weight":1.2}]},{"featureType":"landscape","elementType":"geometry","stylers":[{"color":"#000000"},{"lightness":20}]},{"featureType":"poi","elementType":"geometry","stylers":[{"color":"#000000"},{"lightness":21}]},{"featureType":"road.highway","elementType":"geometry.fill","stylers":[{"color":"#000000"},{"lightness":17}]},{"featureType":"road.highway","elementType":"geometry.stroke","stylers":[{"color":"#000000"},{"lightness":29},{"weight":0.2}]},{"featureType":"road.arterial","elementType":"geometry","stylers":[{"color":"#000000"},{"lightness":18}]},{"featureType":"road.local","elementType":"geometry","stylers":[{"color":"#000000"},{"lightness":16}]},{"featureType":"transit","elementType":"geometry","stylers":[{"color":"#000000"},{"lightness":19}]},{"featureType":"water","elementType":"geometry","stylers":[{"color":"#000000"},{"lightness":17}]}];

		styleSettings.ultralight = [{"featureType":"water","elementType":"geometry","stylers":[{"color":"#e9e9e9"},{"lightness":17}]},{"featureType":"landscape","elementType":"geometry","stylers":[{"color":"#f5f5f5"},{"lightness":20}]},{"featureType":"road.highway","elementType":"geometry.fill","stylers":[{"color":"#ffffff"},{"lightness":17}]},{"featureType":"road.highway","elementType":"geometry.stroke","stylers":[{"color":"#ffffff"},{"lightness":29},{"weight":0.2}]},{"featureType":"road.arterial","elementType":"geometry","stylers":[{"color":"#ffffff"},{"lightness":18}]},{"featureType":"road.local","elementType":"geometry","stylers":[{"color":"#ffffff"},{"lightness":16}]},{"featureType":"poi","elementType":"geometry","stylers":[{"color":"#f5f5f5"},{"lightness":21}]},{"featureType":"poi.park","elementType":"geometry","stylers":[{"color":"#dedede"},{"lightness":21}]},{"elementType":"labels.text.stroke","stylers":[{"visibility":"on"},{"color":"#ffffff"},{"lightness":16}]},{"elementType":"labels.text.fill","stylers":[{"saturation":36},{"color":"#333333"},{"lightness":40}]},{"elementType":"labels.icon","stylers":[{"visibility":"off"}]},{"featureType":"transit","elementType":"geometry","stylers":[{"color":"#f2f2f2"},{"lightness":19}]},{"featureType":"administrative","elementType":"geometry.fill","stylers":[{"color":"#fefefe"},{"lightness":20}]},{"featureType":"administrative","elementType":"geometry.stroke","stylers":[{"color":"#fefefe"},{"lightness":17},{"weight":1.2}]}];

		styleSettings.desaturate = [{"stylers": [{ "saturation": -100 }]}];

		styleSettings.beigeblue = [{"featureType": "administrative","elementType": "geometry.fill","stylers": [{"hue": "#ff0000"}]},{"featureType": "administrative","elementType": "labels.text.fill","stylers": [{"color": "#444444"}]},{"featureType": "landscape","elementType": "all","stylers": [{"color": "#f2f2f2"}]},{"featureType": "poi","elementType": "all","stylers": [{"visibility": "off"}]},{"featureType": "road","elementType": "all","stylers": [{"saturation": -100},{"lightness": 45}]},{"featureType": "road.highway","elementType": "all","stylers": [{"visibility": "simplified"}]},{"featureType": "road.arterial","elementType": "labels.icon","stylers": [{"visibility": "off"}]},{"featureType": "transit","elementType": "all","stylers": [{"visibility": "off"}]},{"featureType": "water","elementType": "all","stylers": [{"color": "#bbd0d8"},{"visibility": "on"}]}];

	$( '.phtpb_map-container' ).each( function( index, element )  {

		var $map = $( element ).find( '.phtpb_map-canvas' ), 
			$map_container = $( this ), 
			i = index;

		if ( $map.length ) {

			myOptions[i] = {
				zoom: $map.data( 'zoom' ),
				center: new google.maps.LatLng( $map.data( 'lat' ), $map.data( 'lng' ) ),
				mapTypeId: google.maps.MapTypeId.ROADMAP,
				scrollwheel: false,
				draggable: $map.data('alwaysdrag') && true === $map.data('alwaysdrag') ? true : !Modernizr.hiddenscroll && !self.palmDeviceScreen,
			};
			if ( 'default' !== $map.data( 'styles' ) ) {
				myOptions[i].styles = styleSettings[ $map.data( 'styles' )];
			}
			map[i] = new google.maps.Map( $map[0], myOptions[i]);

			$map_container.find('.phtpb_marker').each( function( index, element ) {
			
				var markers = {},
					lat = $(element).data('lat'), 
					lng = $(element).data('lng'),
					marker_title = $(element).data('marker-title'),
					position = new google.maps.LatLng( parseFloat( lat ) , parseFloat( lng ) ),
					markerIcon = false,
					args = {
						map: map[i],
						position: position,
						title: marker_title,
					};

				if ( $(element).data( 'image_path' ) ) {
					markerIcon = new google.maps.MarkerImage( $(element).data( 'image_path' ), null, null, null, new google.maps.Size( $(element).data( 'image_width' ) , $(element).data( 'image_height' ) ) );
					if ( markerIcon ) {
						args.icon = markerIcon;
					}
				}

				markers[index] = new google.maps.Marker( args );
			});
		}

	});

};
	

})( jQuery );