/* global yaga_Settings */
/**
 * Add a listener to the Color Scheme control to update other color controls to new values/defaults.
 * Also trigger an update of the Color Scheme CSS when a color is changed.
 */

( function( api ) {

	"use strict";
	
	var cssTemplate = wp.template( yaga_Settings.template ),
	settings = yaga_Settings.settings;

	// Generate the CSS.
	function updateCSS() {
		var css,
			css_settings = _.object( settings );

		_.each( settings, function( setting ) {
			
			css_settings[ setting ] = api( setting )();
			
		});

		css = cssTemplate( css_settings );
		api.previewer.send( 'yaga-update-customizer-css', css );
	}

	_.each( settings, function( setting ) {
		api( setting, function( setting ) {
			setting.bind( updateCSS );
		} );
	} );

} )( wp.customize );