/**
 * Live-update changed settings in real time in the Customizer preview.
 */

( function( $ ) {
	"use strict";
	var api = wp.customize,
	parentApi = parent.wp.customize,
	$style = $( '#yaga-colors-css' );
	$( ".js-unloaded" )
		.removeClass( "js-unloaded" )
		.addClass( "js-loaded" );
	$( "#site-preloader" ).remove();

	if ( ! $style.length ) {
		$style = $( 'head' ).append( '<style type="text/css" id="yaga-colors-css" />' ).find( '#yaga-colors-css' );
	}
		
	// Site title.
	api( 'blogname', function( value ) {
		value.bind( function( to ) {
			$( '.site-title' ).text( to );
		} );
	} );

	// Site tagline.
	api( 'blogdescription', function( value ) {
		value.bind( function( to ) {
			$( '.site-description' ).text( to );
		} );
	} );
	
	api.bind( 'preview-ready', function() {

		api.preview.bind( 'yaga-update-customizer-css', function( css ) {
			$style.html( css );
		} );
	} );

} )( jQuery );