<?php
/**
 *
 * @package   PeHaa Themes Library
 * @author    PeHaa THEMES <info@pehaa.com>
 * @license   GPL-2.0+
 * @copyright 2015 PeHaa THEMES
 */

/**
 *
 * @package PeHaa Themes Library
 * @author  PeHaa THEMES <info@pehaa.com>
 */

if ( ! class_exists( 'PeHaaThemes_Back_Compat' ) ) :

class PeHaaThemes_Back_Compat {

	private $name;

	private $required_version;

	private $message = '';

	public function __construct( $name, $required_version ) { 

		$this->name = $name;

		$this->required_version = $required_version;

		$this->message = $this->upgrade_notice_string();

		add_action( 'after_switch_theme', array( $this, 'switch_theme' ) );
		add_action( 'load-customize.php', array( $this, 'customize' ) );
		add_action( 'template_redirect', array( $this, 'preview' ) );

	}

	public function switch_theme() {
		switch_theme( WP_DEFAULT_THEME, WP_DEFAULT_THEME );
		unset( $_GET['activated'] );
		add_action( 'admin_notices', array( $this, 'upgrade_notice' ) );
	}

	public function upgrade_notice() {

		printf( '<div class="error"><p>%s</p></div>', $this->message );

	}

	private function upgrade_notice_string() {

		$message = sprintf( esc_html__( '%1$s requires at least WordPress version %2$s. You are running version %3$s. Please upgrade and try again.', 'yaga' ),
			$this->name,
			$this->required_version,
			$GLOBALS['wp_version'] 
		);

		return $message;

	}

	public function customize() {
		wp_die( $this->message, '', array( 'back_link' => true ) );
	}

	public function preview() {
		if ( isset( $_GET['preview'] ) ) {
			wp_die( $this->message );
		}
	}
}

endif;