<?php
/**
 * The Template for displaying product archives, including the main shop page which is a post type archive.
 *
 * Override this template by copying it to yourtheme/woocommerce/archive-product.php
 *
 * @author 		WooThemes
 * @package 	WooCommerce/Templates
 * @version     3.3.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

if ( is_shop() && !is_search() ) {
	$yaga_page = new Yaga_Single_View( get_option( 'woocommerce_shop_page_id' ) );
} else {
	$yaga_page = new Yaga_View();
}

get_header( 'shop' ); ?>
	
<div id="primary" class="content-area primary-content-area">
	
	<div id="content" class="site-content cf" role="main">

		<?php $yaga_page->header(); 

		$yaga_page->start_container();

		woocommerce_breadcrumb();

		do_action( 'woocommerce_archive_description' ); 

		if ( have_posts() ) : ?>

			<?php $yaga_page->inner_container_starts(); ?>

			<?php
				/**
				 * woocommerce_before_shop_loop hook
				 *
				 * @hooked woocommerce_result_count - 20
				 * @hooked woocommerce_catalog_ordering - 30
				 */
				do_action( 'woocommerce_before_shop_loop' );
			?>

			<?php woocommerce_product_loop_start(); ?>

				<?php woocommerce_product_subcategories(); ?>

				<?php while ( have_posts() ) : the_post(); ?>

					<?php wc_get_template_part( 'content', 'product' ); ?>

				<?php endwhile; // end of the loop. ?>

			<?php woocommerce_product_loop_end(); ?>

			<?php
				/**
				 * woocommerce_after_shop_loop hook
				 *
				 * @hooked woocommerce_pagination - 10
				 */
				do_action( 'woocommerce_after_shop_loop' );
			?>

			<?php $yaga_page->inner_container_ends(); ?>

		<?php elseif ( ! woocommerce_product_subcategories( array( 'before' => woocommerce_product_loop_start( false ), 'after' => woocommerce_product_loop_end( false ) ) ) ) : ?>

			<?php wc_get_template( 'loop/no-products-found.php' ); ?>

		<?php endif; 

	$yaga_page->get_sidebar();

	$yaga_page->end_container(); ?>

</div><!-- #content -->
</div><!-- #primary -->

<?php get_footer( 'shop' ); ?>