<?php
/**
 * The template for displaying product content within loops
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/content-product.php.
 *
 * HOWEVER, on occasion WooCommerce will need to update template files and you (the theme developer).
 * will need to copy the new files to your theme to maintain compatibility. We try to do this.
 * as little as possible, but it does happen. When this occurs the version of the template file will.
 * be bumped and the readme will list any important changes.
 *
 * @see     http://docs.woothemes.com/document/template-structure/
 * @author  WooThemes
 * @package WooCommerce/Templates
 * @version 3.0.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

global $product, $woocommerce_loop;

// Store loop count we're currently on
if ( empty( $woocommerce_loop['loop'] ) ) {
	$woocommerce_loop['loop'] = 0;
}
// Store column count for displaying the grid
if ( empty( $woocommerce_loop['columns'] ) || is_shop() ) {
	$woocommerce_loop['pht_columns'] = apply_filters( 'loop_shop_columns', PeHaaThemes_Theme_Config::$sidebar->display ? 3 : 4 );
	$woocommerce_loop['columns'] = $woocommerce_loop['pht_columns'];
} else {
	$woocommerce_loop['pht_columns'] = $woocommerce_loop['columns'];
}

// Ensure visibility
if ( ! $product || ! $product->is_visible() ) {
	return;
}

// Increase loop count
$woocommerce_loop['loop']++;
// Extra post classes
if ( 3 === (int) $woocommerce_loop['pht_columns'] ) {
	if ( !empty( $woocommerce_loop['columns'] ) ) {
		$class = 'u-1-of-3-desk u-1-of-3-lap u-1-of-2';
	} else {
		$class = 'u-1-of-3-desk u-1-of-2-lap u-1-of-2';
	}
	
} elseif ( 2 === (int) $woocommerce_loop['pht_columns'] ) {
	$class = 'u-1-of-2-desk u-1-of-2-lap u-1-of-2';
} elseif ( 1 === (int) $woocommerce_loop['pht_columns'] ) { 
	$class = '';
} else {
	$class = 'u-1-of-4-desk u-1-of-3-lap u-1-of-2';
}

?>
--><li <?php post_class( "pht-layout__item u-1-of-1-small pht-mb $class pht-parent" ); ?>>

	<?php do_action( 'woocommerce_before_shop_loop_item' ); 
	/**
	 * woocommerce_before_shop_loop_item_title hook
	 *
	 * @hooked woocommerce_show_product_loop_sale_flash - 10
	 * @hooked woocommerce_template_loop_product_thumbnail - 10
	 */
	do_action( 'woocommerce_before_shop_loop_item_title' );
	
	woocommerce_template_loop_rating(); ?>
	<div class="pht-box pht-box--small pht-box--highlight pht-text-center">
		<h3 class="pht-epsilon pht-mb0 pht-truncate container-a container-a--h"><a href="<?php the_permalink(); ?>"><?php the_title(); ?></a></h3>
		<div class="product-details clearfix">
			<?php
			/**
			 * woocommerce_after_shop_loop_item_title hook
			 *
			 * @hooked woocommerce_template_loop_rating - 5
			 * @hooked woocommerce_template_loop_price - 10
			 */
			do_action( 'woocommerce_after_shop_loop_item_title' );?>
		</div>
		<?php do_action( 'woocommerce_after_shop_loop_item' ); ?>
	</div><!-- .pht-box -->
</li><!--