<?php
/**
 * The template for displaying product category thumbnails within loops
 *
 * This template can be overridden by copying it to yourtheme/woocommerce/content-product_cat.php.
 *
 * HOWEVER, on occasion WooCommerce will need to update template files and you (the theme developer).
 * will need to copy the new files to your theme to maintain compatibility. We try to do this.
 * as little as possible, but it does happen. When this occurs the version of the template file will.
 * be bumped and the readme will list any important changes.
 *
 * @see     http://docs.woothemes.com/document/template-structure/
 * @author  WooThemes
 * @package WooCommerce/Templates
 * @version 2.6.1
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

global $woocommerce_loop;

// Store loop count we're currently on.
if ( empty( $woocommerce_loop['loop'] ) ) {
	$woocommerce_loop['loop'] = 0;
}

// Store column count for displaying the grid.
// Store column count for displaying the grid
if ( empty( $woocommerce_loop['columns'] ) ) {
	$woocommerce_loop['pht_columns'] = apply_filters( 'loop_shop_columns', PeHaaThemes_Theme_Config::$sidebar->display ? 3 : 4 );
	$woocommerce_loop['columns'] = $woocommerce_loop['pht_columns'];
} else {
	$woocommerce_loop['pht_columns'] = $woocommerce_loop['columns'];
}

// Increase loop count.
$woocommerce_loop['loop']++;
// Extra post classes
if ( 3 === (int) $woocommerce_loop['pht_columns'] ) {
	if ( !empty( $woocommerce_loop['columns'] ) ) {
		$class = 'u-1-of-3-desk u-1-of-3-lap u-1-of-2';
	} else {
		$class = 'u-1-of-3-desk u-1-of-2-lap u-1-of-2';
	}
	
} elseif ( 2 === (int) $woocommerce_loop['pht_columns'] ) {
	$class = 'u-1-of-2-desk u-1-of-2-lap u-1-of-2';
} elseif ( 1 === (int) $woocommerce_loop['pht_columns'] ) { 
	$class = '';
} else {
	$class = 'u-1-of-4-desk u-1-of-3-lap u-1-of-2';
}
?>
--><li class="pht-layout__item u-1-of-1-small pht-mb pht-parent <?php echo esc_attr( $class ); ?>">
	<?php
	/**
	 * woocommerce_before_subcategory hook.
	 *
	 * @hooked woocommerce_template_loop_category_link_open - 10
	 */
	do_action( 'woocommerce_before_subcategory', $category );

	/**
	 * woocommerce_before_subcategory_title hook.
	 *
	 * @hooked woocommerce_subcategory_thumbnail - 10
	 */
	do_action( 'woocommerce_before_subcategory_title', $category ); ?>

	<div class="pht-box pht-box--small pht-box--highlight pht-text-center pht-box--product-cat">
		<h3 class="pht-epsilon pht-truncate pht-mt pht-mb container-a container-a--h">
			<a href="<?php echo esc_url( get_term_link( $category->slug, 'product_cat' ) ); ?>">
				<?php echo esc_html( $category->name );

					if ( $category->count > 0 )
						echo apply_filters( 'woocommerce_subcategory_count_html', ' <div class="count">(' . $category->count . ')</div>', $category );
				?>
			</a>
		</h3>
	</div><!-- .pht-box -->
<?php
	/**
	 * woocommerce_after_subcategory_title hook.
	 */
	do_action( 'woocommerce_after_subcategory_title', $category );

	/**
	 * woocommerce_after_subcategory hook.
	 *
	 * @hooked woocommerce_template_loop_category_link_close - 10
	 */
	do_action( 'woocommerce_after_subcategory', $category ); ?>
</li><!--