<?php
/**
 * Order tracking form
 *
 * @author 		WooThemes
 * @package 	WooCommerce/Templates
 * @version     3.3.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

global $post;
?>

<form action="<?php echo esc_url( get_permalink( $post->ID ) ); ?>" method="post" class="track_order">

	<?php do_action( 'yaga_woocommerce_form_start' ); ?>	

	<p><?php esc_html_e( 'To track your order please enter your Order ID in the box below and press the "Track" button. This was given to you on your receipt and in the confirmation email you should have received.', 'yaga' ); ?></p>
	<div class="pht-layout">
		<p class="form-row form-row-first pht-layout__item u-1-of-2-desk"><label for="orderid"><?php _e( 'Order ID', 'yaga' ); ?></label> <input class="input-text" type="text" name="orderid" id="orderid" value="<?php echo isset( $_REQUEST['orderid'] ) ? esc_attr( wp_unslash( $_REQUEST['orderid'] ) ) : ''; ?>" placeholder="<?php esc_attr_e( 'Found in your order confirmation email.', 'yaga' ); ?>" /></p><!--
	--><p class="form-row form-row-last pht-layout__item u-1-of-2-desk"><label for="order_email"><?php _e( 'Billing email', 'yaga' ); ?></label> <input class="input-text" type="text" name="order_email" id="order_email" value="<?php echo isset( $_REQUEST['order_email'] ) ? esc_attr( wp_unslash( $_REQUEST['order_email'] ) ) : ''; ?>" placeholder="<?php esc_attr_e( 'Email you used during checkout.', 'yaga' ); ?>" /></p>
	</div>

	<p class="form-row pht-text-right"><input type="submit" class="button" name="track" value="<?php esc_html_e( 'Track', 'yaga' ); ?>" /></p>
	<?php wp_nonce_field( 'woocommerce-order_tracking' ); ?>
	<?php do_action( 'yaga_woocommerce_form_end' ); ?>

</form>