<?php
/**
 * The Template for displaying all single products.
 *
 * Override this template by copying it to yourtheme/woocommerce/single-product.php
 *
 * @author 		WooThemes
 * @package 	WooCommerce/Templates
 * @version     1.6.4
 */

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

get_header( 'shop' ); 

?>

	<?php
		/**
		 * woocommerce_before_main_content hook
		 *
		 * @hooked woocommerce_output_content_wrapper - 10 (outputs opening divs for the content)
		 * @hooked woocommerce_breadcrumb - 20
		 */
		do_action( 'woocommerce_before_main_content' );
	?>
	
	<?php if ( PeHaaThemes_Theme_Config::$sidebar->display ) { 
		$class = isset( PeHaaThemes_Theme_Config::$sidebar->position ) && 'left' === PeHaaThemes_Theme_Config::$sidebar->position ? 'pht-layout--rev' : '';
		?>
		
		<div class="pht-layout <?php echo esc_attr( $class ); ?> cf">
		<div class="pht-layout__item u-2-of-3-desk u-2-of-3-lap">
		
	<?php } ?>

		<?php while ( have_posts() ) : the_post(); ?>

			<?php wc_get_template_part( 'content', 'single-product' ); ?>

		<?php endwhile; // end of the loop. ?>

	
	</div><!--
	<?php
		/**
		 * woocommerce_sidebar hook
		 *
		 * @hooked woocommerce_get_sidebar - 10
		 */
		do_action( 'woocommerce_sidebar' );
	?>
	
	<?php if ( PeHaaThemes_Theme_Config::$sidebar->display ) { ?>
		
		</div><!-- .grid -->
		
	<?php } ?>
	<?php
		/**
		 * woocommerce_after_main_content hook
		 *
		 * @hooked woocommerce_output_content_wrapper_end - 10 (outputs closing divs for the content)
		 */
		do_action( 'woocommerce_after_main_content' );
	?>

<?php get_footer( 'shop' ); ?>