<?php
/**
 * Single Product Meta
 *
 * @author 		WooThemes
 * @package 	WooCommerce/Templates
 * @version     3.0.0
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

global $product;
$separator = apply_filters( 'yaga_inline_separator', ' &middot; ' );
?>
<div class="product_meta pht-zeta">

	<?php do_action( 'woocommerce_product_meta_start' ); ?>

	<?php if ( wc_product_sku_enabled() && ( $product->get_sku() || $product->is_type( 'variable' ) ) ) : ?>

		<div class="sku_wrapper"><span class="pht-secondfont"><?php esc_html_e( 'SKU:', 'yaga' ); ?></span> <span class="sku" itemprop="sku"><?php echo ( $sku = $product->get_sku() ) ? esc_html( $sku ) : esc_html__( 'N/A', 'yaga' ); ?></span>.</div>

	<?php endif; ?>

	<?php 
	if ( function_exists( 'wc_get_product_category_list' ) ) {
		echo wc_get_product_category_list( $product->get_id(), $separator, '<div class="posted_in"><span class="pht-secondfont">' . _n( 'Category:', 'Categories:', count( $product->get_category_ids() ), 'yaga' ) . '</span> ', '</div>' );
	} else {
		global $post;
		$cat_count = sizeof( get_the_terms( $post->ID, 'product_cat' ) );
		echo get_the_term_list( $post->ID, 'product_cat', '<div class="posted_in"><span class="pht-secondfont">' . esc_html( _n( 'Category:', 'Categories:', $cat_count, 'yaga' ) ) . '</span> ', $separator, '</div>' );
	}
	if ( function_exists( 'echo wc_get_product_tag_list' ) ) {
		echo wc_get_product_tag_list( $product->get_id(), $separator, '<div class="tagged_as"><span class="pht-secondfont">' . _n( 'Tag:', 'Tags:', count( $product->get_tag_ids() ), 'yaga' ) . '</span> ', '</div>' );
	} else {
		global $post;
		$tag_count = sizeof( get_the_terms( $post->ID, 'product_tag' ) );
		 echo get_the_term_list( $post->ID, 'product_tag', '<div class="tagged_as"><span class="pht-secondfont">' . esc_html( _n( 'Tag:', 'Tags:', $tag_count, 'yaga' ) ) . '</span>  ', $separator, '</div>' );
	} ?>

	<?php do_action( 'woocommerce_product_meta_end' ); ?>

</div>